--
-- Aardvark
-- Version: AR 8.2.8.2
-- Author: walkerbo.saurfang@gmail.com
-- Date: Thursday 26 September 2019
--

-- I have tried to name variables, functions, frames, and buttons to be more descriptive

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Metrics, Lists & Variables          ===========================
-- ===================================================================================================
-- ===================================================================================================

local addonName = "Aardvark"
local versionNumber = "AR 8.2.8.2"
local playerName = GetUnitName("player")

-- Floating button and action bar buttons
local AardvarkActionBar,
    ActionBarAardvarkButton,
    ActionBarDestroyButton,
    ActionBarSellButton,
    ActionBarProtectGlobalButton,
    ActionBarProtectCharacterButton,
    ActionBarDestroyGlobalButton,
    ActionBarDestroyCharacterButton,
    ActionBarSellGlobalButton,
    ActionBarSellCharacterButton,
    AardvarkMagicButton

-- Repair variables to populate repair messages after the sell message
local repairAmount, repairMessageType = 0, 0

-- Empty table variables for adding items and filtering
local tempItemList, tempGlobalSellTable, tempCharacterSellTable, tempGlobalDestroyTable, tempCharacterDestroyTable, tempGlobalProtectTable, tempCharacterProtectTable = {}, {}, {}, {}, {}, {}, {}

-- A table of all the Aardvark images
local ImageList = {
    avkBanner = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkBanner", --  Aardvark Banner
    avkButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkButton",--  Aardvark Buttons
    avkButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkButtonHover",
    avkCloseButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkCloseButton",
    avkCloseButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\avkCloseButtonHover",
    sellButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellButton", -- Aardvark Sell Buttons
    sellButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellButtonHover",
    sellOutOfRange = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOutOfRange",
    sellGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellGlobal",
    sellGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellGlobalHover",
    sellCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellCharacter",
    sellCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellCharacterHover",
    sellOptions = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOptions",
    sellOptionsHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellOptionsHover",
    sellFilters = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellFilters",
    sellFiltersHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\sellFiltersHover",
    destroyButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyButton", -- Aardvark Destroy Buttons
    destroyButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyButtonHover",
    destroyCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyCharacter",
    destroyCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyCharacterHover",
    destroyGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyGlobal",
    destroyGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyGlobalHover",
    destroyOptions = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyOptions",
    destroyOptionsHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyOptionsHover",
    destroyFilters = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyFilters",
    destroyFiltersHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\destroyFiltersHover",
    protectButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectButton", -- Aardvark Protect Buttons
    protectButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectButtonHover",
    protectCharacter = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectCharacter",
    protectCharacterHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectCharacterHover",
    protectGlobal = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectGlobal",
    protectGlobalHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectGlobalHover",
    protectOptions = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectOptions",
    protectOptionsHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectOptionsHover",
    protectFilters = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectFilters",
    protectFiltersHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\protectFiltersHover",
    repairButton = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\repairButton", -- Aardvark Repair Buttons
    repairButtonHover = "Interface\\AddOns\\Aardvark\\Files\\Buttons\\repairButtonHover"
}

-- Font objects
local FontCheckBoxBig = CreateFont("FontCheckBoxBig")
FontCheckBoxBig:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\neuropol.ttf", 29)
local FontCheckBox = CreateFont("FontCheckBox")
FontCheckBox:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 17)
local FontContent = CreateFont("FontContent")
FontContent:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 14.7)
local FontTitleScroll = CreateFont("FontTitleScroll")
FontTitleScroll:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 20)
local FontButton = CreateFont("FontButton")
FontButton:SetFont("Interface\\AddOns\\Aardvark\\Files\\Fonts\\vixar.TTF", 15)

-- The font colours
local ColourList = {
    rarityPoor = "|cff9d9d9d", --  Poor rgb(157, 157, 157)
    rarityCommon = "|cffffffff", -- Common rgb(255, 255, 255)
    rarityUncommon = "|cff1eff00", --  Uncommon rgb(30, 255, 0)
    rarityRare = "|cff0070dd", --  Rare rgb(0, 112, 221)
    rarityEpic = "|cffa335ee", -- Epic rgb(163, 53, 238)
    rarityLegendary = "|cffff8000", --  Legendary rgb(255, 128, 0)
    rarityArtifact = "|cffe6cc80", --  Artifact rgb(230, 204, 128)
    rarityHeirloom = "|cff00ccff", --  Heirloom rgb(0, 204, 255)
    rarityOther = "|cff00ccff", --  Other rgb(100, 0, 0)
    textBlue = "|cff00ffff", -- rgb(0,255,255)
    textBluePrefix = "|cff00ffff [" .. addonName .. "]: ", -- rgb(0,255,255)
    textBluePrefixSuffix = "|cff00ffff [" .. addonName .. "]: |r", -- rgb(0,255,255)
    textGreen = "|cff00ff00", -- rgb(0,255,0)
    textOrange = "|cffff8c00", -- rgb(255,140,0)
    textPink = "|cffff00ff", -- rgb(255,0,255)
    textRed = "|cffff0000" -- rgb(255,0,0)
}

-- Content strings
local TextList = {
    avkLoad = (ColourList.textBlue .. " *** " .. addonName .. " - " .. versionNumber .. " Loaded *** \n"), -- Load Message
    avkOptions = ("Slash Commands:\n" ..
        ColourList.textBlue ..
            "/avk |r ~  Show/Hide Aardvark frame\n" ..
                ColourList.textBlue ..
                    "/avkdestroy |r ~  Destroy function\n" ..
                        ColourList.textBlue ..
                            "/avkclear |r ~  Clear all lists\n" ..
                                ColourList.textBlue .. "/avkpos |r ~  Reset Aardvark frame and button positions\n"), -- Options Text
    avkSellOptions = ("The " ..
        ColourList.textGreen ..
            "Aardvark Sell|r function can sometimes lag depending on the size of your list and the number items you have in your bags.\n\nIf this occurs turn on the  action bar and spam the sell button.\n\nI will continue to tinker with the sell function to try and remove this issue."), -- Sell Text
    avkDestroyOptions = ("The " ..
        ColourList.textRed ..
            "Aardvark Destroy|r function will destroy|r the items that you have added to your destroy lists regardless of bind, value, rarity or colour.\n\n" ..
                ColourList.textRed ..
                    "Destroyed items CANNOT be recovered.|r\n\nThere are no take backs, no do-overs, no whoops didn't mean to do that, etc.\n\nThe only way to  recover a destroyed item is to go and farm it again.\n\n" ..
                        ColourList.textRed .. "You have been warned!"), -- Destroy Text
    avkRepairOptions = ("The " ..
        ColourList.textPink ..
            "Aardvark Repair|r function operates after the destroy function and prior to the\n sell function.\n\n Damaged items must\n be repaired before\n they can  be sold."), -- Repair Text
    avkProtectOptions = ("The " ..
        ColourList.textOrange ..
            "Aardvark Protect|r function was created to protect those special items that you want to ensure are not sold or destroyed even if they are listed in your other sell and/or destroy lists.\n\nThe protect lists have no restrictions which means you can protect any item regardless of colour or value."), -- Protect Text
    avkMagicButton = ("Drag&Drop/Click&Drop: Add Item to Character List\nDrag&Drop/Click&Drop + Alt: Add Item to Global List\nDrag&Drop/Click&Drop + Ctrl: Add Item to Protect List\nLeft Click: Show/Hide Aardvark Frame\nMiddle Click + Drag: Move Aardvark Button\nMiddle Click + Drag: Move Aardvark Action Bar\nRight Click: Destroy Listed Items"), -- Aardvark Button Tooltip Text
    avkAboutAardvark = ("There once was a little blue Aardvark that grew up in Azeroth.\n\nHe loved to farm, spending all day and half of the night digging up herbs, mining ore, weaving cloth and collecting little treasures.\n\nAfter few years he started to develop RSI in his little paws as he was always clicking to sell items that he didn't want, dragging and dropping items that he couldn't sell and, in a lot of cases, deleting items just to clean out his bags ready to farm again.\n\nOne day after an extremely long day of farming he thought;" ..
        ColourList.textBlue ..
            '\n"What if I could open my bags and have all the stuff I don\'t want just magically disappear?"|r \n\nWith this thought he started to teach his little arthritic paws how to code.\nHis code is very messy, overly long and undoubtedly very inefficient but it does what he wants it to do.\n\nHopefully you can find it useful too.') -- Aardvark Text
}

-- All sizings
local SizeList = {
    scaleButtonGap = 50,
    actionBarContainerLong = 130,
    actionBarButtonGap = 5,
    actionBarSmallButton = 28,
    backdropEdgeSize = 20,
    checkBoxBigSize = 24,
    checkBoxSize = 22,
    checkBoxChildGapX = 15,
    checkboxBigGapY = 38,
    checkboxGapY = 32,
    clearButtonHight = 32,
    closeButtonGap = -8,
    closeButtonSize = 20,
    mainFrameHeight = 580,
    mainFrameMarginGap = 10,
    mainFrameNavigationButtonSize = 40,
    mainFrameNavigationButtonSpace = 76,
    mainFrameNavigationFrameHeight = 60,
    mainFrameSetPoint = 250,
    mainFrameWidth = 610,
    mainPanelElementGap = 20,
    mainPanelHeight = 343,
    mainPanelWidth = 590,
    optionsButtonSize = 25,
    optionsFrameWidth = 360,
    optionsFrameElementGap = 10,
    scaleSliderMin = .5,
    scaleSliderMax = 1.5,
    scaleSliderScale = 1.2,
    scrollButtonHeight = 16,
    scrollButtonNumber = 13,
    scrollButtonWidth = 267,
    scrollFrameHeight = 223,
    scrollFrameWidth = 282,
    scrollTitleHeight = 48,
    scrollTitlePointX = 10,
    scrollTitlePointY = -16,
    textBoxWidthShrink = 35,
    toolTipAnchor = -22
}

-- List of vendors that will not buy items
local VendorBlacklist = {
    98737, -- Holt Thunderhorn -- Hunter class hall
    97111, -- Illanna Dreadmoore -- Death Knight class hall
    91190, -- Sister Elda -- Paladin class hall
    87302, -- Murg -- Horde garrison inn chef
    79828, -- Murg -- Horde garrison inn chef - Yes, this is a second Murg - No, I have no idea why
    -- 77368, -- Madison Clark -- This NPC can now buy items
    63596, -- Audrey Burnhep
    27914, -- Ethereal Soul Trader
    111741, -- Fjornson Stonecarver -- Warrior class hall
    111740, -- Mile Raitheborne -- Warlock class hall
    111739, -- Gorma Windspeaker -- Shaman class hall
    111738, -- Juvess the Duskwhisperer -- Priest class hall
    111737, -- Celadine the Fatekeeper -- Druid class hall
    111736, -- Vahu the Weathered -- Demon Hunter class hall
    110624, -- Edirah -- Mage class hall
    106942, -- Lorewalker Cho -- Monk class hall
    102641 -- Filius Sparkstache -- Rogue class hall
}

-- Options filter table
local FilterList = {
    armourCloth = true,
    armourLeather = true,
    armourMail = true,
    armourPlate = true,
    bindingNone = true,
    bindOnEquip = true,
    bindOnPickup = true,
    bindSoulbound = true,
    bindToAccount = true,
    otherBags = true,
    otherEnchantments = true,
    otherFoodDrink = true,
    otherGems = true,
    otherMounts = true,
    otherOther = true,
    otherPets = true,
    otherReagents = true,
    otherRecipes = true,
    rarityPoor = true,
    rarityCommon = true,
    rarityUncommon = true,
    rarityRare = true,
    rarityEpic = true,
    rarityLegendary = true,
    rarityArtifact = true,
    rarityHeirloom = true,
    rarityOther = true,
    slotChest = true,
    slotCloak = true,
    slotFeet = true,
    slotHands = true,
    slotHead = true,
    slotLegs = true,
    slotNeck = true,
    slotRings = true,
    slotShirt = true,
    slotShoulders = true,
    slotTabard = true,
    slotTrinkets = true,
    slotWaist = true,
    slotWrists = true,
    valueValuable = true,
    valueWorthless = true,
    weaponOffHand = true,
    weaponOneHanded = true,
    weaponRanged = true,
    weaponTwoHanded = true
}

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Functions & Slash Commands          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- start up function to initialise tables
local function avkInitialise()
    if not AVKGlobalSettings then -- create aardvark options table if it does not already exist
        AVKGlobalSettings = {
            Aardvark = {
                amfb = true, -- Aardvark main floating button
                amfbt = true, -- Aardvark main floating button tooltip
                afab = true, -- Aardvark floating action bar
                afabas = true, -- Aardvark floating action bar always show
                afabv = true -- Aardvark floating action bar vertical
            },
            Destroy = {
                ded = true, -- Destroy enable destroy
                dead = true, -- Destroy enable auto destroy
                dddm = true, -- Destroy detailed destroy messages
                dntdm = true, -- Destroy nothing to destroy messages
                dialsm = true, -- Destroy item added to list success messages
                dialfm = true, -- Destroy item added to list fail messages
                dlit = true -- Destroy show listed item tooltips
            },
            Repair = {
                rer = true, -- Repair enable repair
                rgr = false, -- Repair guild repair
                rcarm = true, -- Repair cannot afford repair messages
                rntrm = true, -- Repair nothing to repair messages
                rvcrm = true -- Repair vendor cannot repair messages
            },
            Sell = {
                ses = true, -- Sell enable sell
                seas = true, -- Sell enable auto sell
                seasg = true, -- Sell enable auto sell greys
                stil = false, -- Sell twelve item limit
                sdsm = true, -- Sell detailed sell messages
                sntsm = true, -- Sell nothing to sell messages
                sialsm = true, -- Sell item added to list success messages
                sialfm = true, -- Sell item added to list fail messages
                slit = true -- Sell show listed item tooltips
            },
            Protect = {
                pialsm = true, -- Protect item added to list success messages
                pdpm = true, -- Protect display protected messages
                pcbp = true, -- Protect caged battle pets
                plit = true -- Protect show listed item tooltips
            },
            FrameScales = {
                amfs = 1, -- Aardvark Main Frame Scale
                ambs = 1, -- Aardvark Magic Button Scale
                aabs = 1 -- Aardvark Action Bar Scale
            }
        }
        AardvarkMainFrame:Show() -- Show Aardvark frame if the settings list did not already exist
    end
    if not AVKGlobalSellTable then -- create empty global sell table if it does not already exist
        AVKGlobalSellTable = {}
    end
    if not AVKGlobalDestroyTable then -- create empty global destroy table if it does not already exist
        AVKGlobalDestroyTable = {}
    end
    if not AVKGlobalProtectTable then -- create empty global protect table if it does not already exist
        AVKGlobalProtectTable = {}
    end
--    if not AVKGlobalConverted then -- create global convert variable and set to false -- debug --
--        AVKGlobalConverted = false
--    end
    if not AVKCharacterSellTable then -- create empty character sell table if it does not already exist
        AVKCharacterSellTable = {}
    end
    if not AVKCharacterDestroyTable then -- create empty character destroy table if it does not already exist
        AVKCharacterDestroyTable = {}
    end
    if not AVKCharacterProtectTable then -- create empty character protect table if it does not already exist
        AVKCharacterProtectTable = {}
    end
--    if not AVKCharacterConverted then -- create character convert variable and set to false -- debug --
--        AVKCharacterConverted = false
--    end
    for k, v in pairs(AVKGlobalSettings) do -- Set all checkboxes
        for a, b in pairs(v) do
            if k ~= 'FrameScales' then
                local checkBoxName = 'CB' .. a
                _G[checkBoxName]:SetChecked(b)
                if k == 'Aardvark' and AVKGlobalSettings.Aardvark.afab == false and (a == 'afabas' or a == 'afabv') then -- Hide option checkboxes if their parent is unchecked
                    _G[checkBoxName]:Hide()
                elseif k == 'Sell' and a ~= 'ses' and AVKGlobalSettings.Sell.ses == false then
                    _G[checkBoxName]:Hide()
                elseif k == 'Destroy' and a ~= 'ded' and AVKGlobalSettings.Destroy.ded == false then
                    _G[checkBoxName]:Hide()
                elseif k == 'Repair' and a ~= 'rer' and AVKGlobalSettings.Repair.rer == false then
                    _G[checkBoxName]:Hide()
                end
            end
        end
    end
    if AVKGlobalSettings.Aardvark.amfb == false then -- Hide magic button if it is set to hide
        AardvarkMagicButton:Hide()
    end
    if AVKGlobalSettings.Aardvark.afab == true and AVKGlobalSettings.Aardvark.afabas == true then -- Show action bar if always show is checked
        AardvarkActionBar:Show()
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===================================================================================================

-- my hook functions
hooksecurefunc(
    "CloseBackpack",function()
        print("CloseBackpack hookedfunction fired")
    end
)
hooksecurefunc(
    "OpenBackpack",function()
        print("OpenBackpack hookedfunction fired")
    end
)
hooksecurefunc(
    "ToggleBackpack",function()
        print("ToggleBackpack hookedfunction fired")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===================================================================================================

-- function to protect caged battle pets
local function avkProtectCagedPet()
    if AVKGlobalSettings.Protect.pcbp then
        local BattlePetCageListed = false
        for k, v in pairs(AVKGlobalProtectTable) do
            if v.itemID == 82800 then
                BattlePetCageListed = true
                break
            end
        end
        if BattlePetCageListed then
            BattlePetCageListed = false
        else
            BattlePetCageListed = false

            tempItemList = {
                itemID = 82800,
                itemName = "Pet Cage",
                itemLink = "|cff0070dd|Hitem:82800::::::::19:256::::::|h[Pet Cage]|h|r",
                itemRarity = 3,
                itemLevel = 20,
                itemMinLevel = 0,
                itemType = "Battle Pets",
                itemSubType = "BattlePet",
                itemStackCount = 1,
                itemEquipLoc = "",
                iconFileDataID = 132599,
                itemSellPrice = 0,
                itemClassID = 17,
                itemSubClassID = 0,
                bindType = 0,
                expacID = 0,
                itemSetID = nil,
                isCraftingReagent = false
            }
            table.insert(AVKGlobalProtectTable, 1, tempItemList)
        end
        BattlePetCageListed = false
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===================================================================================================

-- filter function
    local function avkCheckFilter(itemID)
        for k, v in pairs(AVKGlobalSellTable) do
            if v.itemID == itemID then
                if
                    (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                        (FilterList.rarityUncommon and v.itemRarity == 2) or
                        (FilterList.rarityRare and v.itemRarity == 3) or
                        (FilterList.rarityEpic and v.itemRarity == 4) or
                        (FilterList.rarityHeirloom and v.itemRarity == 7) or
                        (FilterList.rarityLegendary and v.itemRarity == 5) or
                        (FilterList.rarityArtifact and v.itemRarity == 6)
                 then
                    return true
                end
            end
        end
        for k, v in pairs(AVKGlobalDestroyTable) do
            if v.itemID == itemID then
                if
                    (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                        (FilterList.rarityUncommon and v.itemRarity == 2) or
                        (FilterList.rarityRare and v.itemRarity == 3) or
                        (FilterList.rarityEpic and v.itemRarity == 4) or
                        (FilterList.rarityHeirloom and v.itemRarity == 7) or
                        (FilterList.rarityLegendary and v.itemRarity == 5) or
                        (FilterList.rarityArtifact and v.itemRarity == 6)
                 then
                    return true
                end
            end
        end
        for k, v in pairs(AVKGlobalProtectTable) do
            if v.itemID == itemID then
                if
                    (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                        (FilterList.rarityUncommon and v.itemRarity == 2) or
                        (FilterList.rarityRare and v.itemRarity == 3) or
                        (FilterList.rarityEpic and v.itemRarity == 4) or
                        (FilterList.rarityHeirloom and v.itemRarity == 7) or
                        (FilterList.rarityLegendary and v.itemRarity == 5) or
                        (FilterList.rarityArtifact and v.itemRarity == 6)
                 then
                    return true
                end
            end
        end
        for k, v in pairs(AVKCharacterSellTable) do
            if v.itemID == itemID then
                if
                    (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                        (FilterList.rarityUncommon and v.itemRarity == 2) or
                        (FilterList.rarityRare and v.itemRarity == 3) or
                        (FilterList.rarityEpic and v.itemRarity == 4) or
                        (FilterList.rarityHeirloom and v.itemRarity == 7) or
                        (FilterList.rarityLegendary and v.itemRarity == 5) or
                        (FilterList.rarityArtifact and v.itemRarity == 6)
                 then
                    return true
                end
            end
        end
        for k, v in pairs(AVKCharacterDestroyTable) do
            if v.itemID == itemID then
                if
                    (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                        (FilterList.rarityUncommon and v.itemRarity == 2) or
                        (FilterList.rarityRare and v.itemRarity == 3) or
                        (FilterList.rarityEpic and v.itemRarity == 4) or
                        (FilterList.rarityHeirloom and v.itemRarity == 7) or
                        (FilterList.rarityLegendary and v.itemRarity == 5) or
                        (FilterList.rarityArtifact and v.itemRarity == 6)
                 then
                    return true
                end
            end
        end
        for k, v in pairs(AVKCharacterProtectTable) do
            if v.itemID == itemID then
                if
                    (FilterList.rarityPoor and v.itemRarity == 0) or (FilterList.rarityCommon and v.itemRarity == 1) or
                        (FilterList.rarityUncommon and v.itemRarity == 2) or
                        (FilterList.rarityRare and v.itemRarity == 3) or
                        (FilterList.rarityEpic and v.itemRarity == 4) or
                        (FilterList.rarityHeirloom and v.itemRarity == 7) or
                        (FilterList.rarityLegendary and v.itemRarity == 5) or
                        (FilterList.rarityArtifact and v.itemRarity == 6)
                 then
                    return true
                end
            end
        end
    end

-- ===================================================================================================
-- ===================================================================================================
-- ===================================================================================================

-- update lists function
    local function avkUpdateLists()
    avkProtectCagedPet()
    -- Clean all temp tables
    wipe(tempGlobalSellTable)
    wipe(tempCharacterSellTable)
    wipe(tempGlobalDestroyTable)
    wipe(tempCharacterDestroyTable)
    wipe(tempGlobalProtectTable)
    wipe(tempCharacterProtectTable)
    -- Populate temp tables with the filtered items
    for index = 1, #AVKGlobalSellTable do
        if avkCheckFilter(AVKGlobalSellTable[index].itemID) then
            table.insert(tempGlobalSellTable, AVKGlobalSellTable[index]["itemLink"])
        end
    end
    for index = 1, #AVKCharacterSellTable do
        if avkCheckFilter(AVKCharacterSellTable[index].itemID) then
            table.insert(tempCharacterSellTable, AVKCharacterSellTable[index]["itemLink"])
        end
    end
    for index = 1, #AVKGlobalDestroyTable do
        if avkCheckFilter(AVKGlobalDestroyTable[index].itemID) then
            table.insert(tempGlobalDestroyTable, AVKGlobalDestroyTable[index]["itemLink"])
        end
    end
    for index = 1, #AVKCharacterDestroyTable do
        if avkCheckFilter(AVKCharacterDestroyTable[index].itemID) then
            table.insert(tempCharacterDestroyTable, AVKCharacterDestroyTable[index]["itemLink"])
        end
    end
    for index = 1, #AVKGlobalProtectTable do
        if avkCheckFilter(AVKGlobalProtectTable[index].itemID) then
            table.insert(tempGlobalProtectTable, AVKGlobalProtectTable[index]["itemLink"])
        end
    end
    for index = 1, #AVKCharacterProtectTable do
        if avkCheckFilter(AVKCharacterProtectTable[index].itemID) then
            table.insert(tempCharacterProtectTable, AVKCharacterProtectTable[index]["itemLink"])
        end
    end

    -- update scroll frames
    FauxScrollFrame_Update(
        AardvarkSellGlobalScrollFrame,
        #tempGlobalSellTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        local offset = index + FauxScrollFrame_GetOffset(AardvarkSellGlobalScrollFrame)
        local button = AardvarkSellGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #tempGlobalSellTable then
--            local itemName, itemLink = GetItemInfo(AVKGlobalSellTable[offset])
            button:SetText(tempGlobalSellTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    FauxScrollFrame_Update(
        AardvarkSellCharacterScrollFrame,
        #tempCharacterSellTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        local offset = index + FauxScrollFrame_GetOffset(AardvarkSellCharacterScrollFrame)
        local button = AardvarkSellCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #tempCharacterSellTable then
--            local itemName, itemLink = GetItemInfo(AVKCharacterSellTable[offset])
            button:SetText(tempCharacterSellTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    FauxScrollFrame_Update(
        AardvarkDestroyGlobalScrollFrame,
        #tempGlobalDestroyTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        local offset = index + FauxScrollFrame_GetOffset(AardvarkDestroyGlobalScrollFrame)
        local button = AardvarkDestroyGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #tempGlobalDestroyTable then
--            local itemName, itemLink = GetItemInfo(AVKGlobalDestroyTable[offset])
            button:SetText(tempGlobalDestroyTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    FauxScrollFrame_Update(
        AardvarkDestroyCharacterScrollFrame,
        #tempCharacterDestroyTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        local offset = index + FauxScrollFrame_GetOffset(AardvarkDestroyCharacterScrollFrame)
        local button = AardvarkDestroyCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #tempCharacterDestroyTable then
--            local itemName, itemLink = GetItemInfo(AVKCharacterDestroyTable[offset])
            button:SetText(tempCharacterDestroyTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    FauxScrollFrame_Update(
        AardvarkProtectGlobalScrollFrame,
        #tempGlobalProtectTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        local offset = index + FauxScrollFrame_GetOffset(AardvarkProtectGlobalScrollFrame)
        local button = AardvarkProtectGlobalScrollFrame.buttons[index]
        button.index = offset
        if offset <= #tempGlobalProtectTable then
--            local itemName, itemLink = GetItemInfo(AVKGlobalProtectTable[offset])
            button:SetText(tempGlobalProtectTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    FauxScrollFrame_Update(
        AardvarkProtectCharacterScrollFrame,
        #tempCharacterProtectTable,
        SizeList.scrollButtonNumber,
        SizeList.scrollButtonHeight
    )
    for index = 1, SizeList.scrollButtonNumber do
        local offset = index + FauxScrollFrame_GetOffset(AardvarkProtectCharacterScrollFrame)
        local button = AardvarkProtectCharacterScrollFrame.buttons[index]
        button.index = offset
        if offset <= #tempCharacterProtectTable then
--            local itemName, itemLink = GetItemInfo(AVKCharacterProtectTable[offset])
            button:SetText(tempCharacterProtectTable[offset])
            button:Show()
        else
            button:Hide()
        end
    end
    avkProtectCagedPet()
end

 -- main frame navigation buttons function
local function toggleAVKPanels(buttonName)
avkUpdateLists()
    if buttonName == AardvarkMainFrameCloseButton then
        AardvarkMainFrame:Hide()
        AardvarkScalePanel:Hide()
        AardvarkSideOptionsPanel:Hide()
    elseif
        buttonName == AardvarkDestroyFiltersButton or buttonName == AardvarkProtectFiltersButton or
            buttonName == AardvarkSellFiltersButton
     then
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSideOptionsPanel:Show()
        AardvarkFilterOptionsPanel:Show()
    elseif buttonName == AardvarkDestroyOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Show()
        AardvarkSideOptionsPanel:Show()
    elseif buttonName == AardvarkSellOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Show()
        AardvarkSideOptionsPanel:Show()
    elseif buttonName == AardvarkProtectOptionsButton then
        AardvarkFilterOptionsPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkProtectOptionsPanel:Show()
        AardvarkSideOptionsPanel:Show()
    elseif buttonName == AardvarkMagicButton then
        if AardvarkMainFrame:IsVisible() then
            AardvarkMainFrame:Hide()
        else
            AardvarkMainFrame:Show()
        end
    elseif buttonName == AardvarkNavigationAardvarkButton then
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideOptionsPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkAardvarkPanel:Show()
    elseif buttonName == AardvarkNavigationDestroyButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSillyPanel:Hide()
        if not AardvarkFilterOptionsPanel:IsVisible() then
            AardvarkFilterOptionsPanel:Hide()
            AardvarkDestroyOptionsPanel:Show()
        end
        AardvarkDestroyPanel:Show()
    elseif buttonName == AardvarkNavigationSellButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectOptionsPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSillyPanel:Hide()
        if not AardvarkFilterOptionsPanel:IsVisible() then
            AardvarkFilterOptionsPanel:Hide()
            AardvarkSellOptionsPanel:Show()
        end
        AardvarkSellPanel:Show()
    elseif buttonName == AardvarkNavigationProtectButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyOptionsPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSellOptionsPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSillyPanel:Hide()
        if not AardvarkFilterOptionsPanel:IsVisible() then
            AardvarkFilterOptionsPanel:Hide()
            AardvarkProtectOptionsPanel:Show()
        end
        AardvarkProtectPanel:Show()
    elseif buttonName == AardvarkNavigationRepairButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideOptionsPanel:Hide()
        AardvarkSillyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Show()
    elseif buttonName == AardvarkNavigationSillyButton then
        AardvarkAardvarkPanel:Hide()
        AardvarkDestroyPanel:Hide()
        AardvarkProtectPanel:Hide()
        AardvarkRepairPanel:Hide()
        AardvarkSellPanel:Hide()
        AardvarkSideOptionsPanel:Hide()
        AardvarkSillyPanel:Show()
    elseif buttonName == AardvarkSideFrameCloseButton then
        AardvarkSideOptionsPanel:Hide()
    elseif buttonName == AardvarkScaleFrameButton then
        if AardvarkScalePanel:IsVisible() then
            AardvarkScalePanel:Hide()
            AardvarkScalePanel:ClearAllPoints()
            AardvarkScalePanel:SetPoint("BOTTOMLEFT", AardvarkMainFrame, "BOTTOMRIGHT", 0, 0)
        else
            AardvarkScalePanel:ClearAllPoints()
            AardvarkScalePanel:SetPoint("BOTTOMLEFT", AardvarkMainFrame, "BOTTOMRIGHT", 0, 0)
            AardvarkScalePanel:Show()
        end
    elseif buttonName == AardvarkScaleFrameCloseButton then
        AardvarkScalePanel:Hide()
    else
        print("FAILED", buttonName) -- If button does not exist
    end
    avkUpdateLists()
end

local function toggleFloatingActionBar()
    if AVKGlobalSettings.Aardvark.afab == true and
            (AVKGlobalSettings.Aardvark.afabas == true or ActionBarSellButton:IsEnabled())
     then
        AardvarkActionBar:Show()
    else
        AardvarkActionBar:Hide()
    end
end

local function toggleVerticleActionBar() -- layout the action bar buttons
    if AVKGlobalSettings.Aardvark.afabv == true then
        AardvarkActionBar:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.actionBarContainerLong)
        ActionBarAardvarkButton:ClearAllPoints()
        ActionBarAardvarkButton:SetPoint("TOP")
        ActionBarDestroyButton:SetPoint("CENTER")
        ActionBarSellButton:SetPoint("BOTTOM")
        ActionBarProtectGlobalButton:ClearAllPoints()
        ActionBarProtectGlobalButton:SetPoint("LEFT", ActionBarAardvarkButton, "RIGHT", SizeList.actionBarButtonGap, 0)
        ActionBarProtectCharacterButton:ClearAllPoints()
        ActionBarProtectCharacterButton:SetPoint(
            "LEFT",
            ActionBarProtectGlobalButton,
            "RIGHT",
            SizeList.actionBarButtonGap,
            0
        )
        ActionBarDestroyGlobalButton:ClearAllPoints()
        ActionBarDestroyGlobalButton:SetPoint("LEFT", ActionBarDestroyButton, "RIGHT", SizeList.actionBarButtonGap, 0)
        ActionBarDestroyCharacterButton:ClearAllPoints()
        ActionBarDestroyCharacterButton:SetPoint(
            "LEFT",
            ActionBarDestroyGlobalButton,
            "RIGHT",
            SizeList.actionBarButtonGap,
            0
        )
        ActionBarSellGlobalButton:ClearAllPoints()
        ActionBarSellGlobalButton:SetPoint("LEFT", ActionBarSellButton, "RIGHT", SizeList.actionBarButtonGap, 0)
        ActionBarSellCharacterButton:ClearAllPoints()
        ActionBarSellCharacterButton:SetPoint(
            "LEFT",
            ActionBarSellGlobalButton,
            "RIGHT",
            SizeList.actionBarButtonGap,
            0
        )
    else
        AardvarkActionBar:SetSize(SizeList.actionBarContainerLong, SizeList.mainFrameNavigationButtonSize)
        ActionBarAardvarkButton:ClearAllPoints()
        ActionBarAardvarkButton:SetPoint("LEFT")
        ActionBarDestroyButton:SetPoint("CENTER")
        ActionBarSellButton:SetPoint("RIGHT")
        ActionBarProtectGlobalButton:ClearAllPoints()
        ActionBarProtectGlobalButton:SetPoint("TOP", ActionBarAardvarkButton, "BOTTOM", 0, -SizeList.actionBarButtonGap)
        ActionBarProtectCharacterButton:ClearAllPoints()
        ActionBarProtectCharacterButton:SetPoint(
            "TOP",
            ActionBarProtectGlobalButton,
            "BOTTOM",
            0,
            -SizeList.actionBarButtonGap
        )
        ActionBarDestroyGlobalButton:ClearAllPoints()
        ActionBarDestroyGlobalButton:SetPoint("TOP", ActionBarDestroyButton, "BOTTOM", 0, -SizeList.actionBarButtonGap)
        ActionBarDestroyCharacterButton:ClearAllPoints()
        ActionBarDestroyCharacterButton:SetPoint(
            "TOP",
            ActionBarDestroyGlobalButton,
            "BOTTOM",
            0,
            -SizeList.actionBarButtonGap
        )
        ActionBarSellGlobalButton:ClearAllPoints()
        ActionBarSellGlobalButton:SetPoint("TOP", ActionBarSellButton, "BOTTOM", 0, -SizeList.actionBarButtonGap)
        ActionBarSellCharacterButton:ClearAllPoints()
        ActionBarSellCharacterButton:SetPoint(
            "TOP",
            ActionBarSellGlobalButton,
            "BOTTOM",
            0,
            -SizeList.actionBarButtonGap
        )
    end
end

-- check item on list functions
local function checkItemOnGlobalSellList(cursorItemID)
    for k, v in pairs(AVKGlobalSellTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
    return false
end
local function checkItemOnCharacterSellList(cursorItemID)
    for k, v in pairs(AVKCharacterSellTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
    return false
end
local function checkItemOnGlobalDestroyList(cursorItemID)
    for k, v in pairs(AVKGlobalDestroyTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
    return false
end
local function checkItemOnCharacterDestroyList(cursorItemID)
    for k, v in pairs(AVKCharacterDestroyTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
    return false
end
local function checkItemOnGlobalProtectedList(cursorItemID)
    for k, v in pairs(AVKGlobalProtectTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
    return false
end
local function checkItemOnCharacterProtectedList(cursorItemID)
    for k, v in pairs(AVKCharacterProtectTable) do
        if v.itemID == cursorItemID then
            return true
        end
    end
    return false
end

--[[
	local function consolidateLists()  --  review
	print("consolidateLists")
	end
--]]
-- add item to list functions
local function addItemToGlobalProtectList()
    local cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= "item" then -- If not item end
        print(ColourList.textBluePrefixSuffix .. " That was not an item.") -- Cannot disable this message, because we have to learn
    else
            local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,iconFileDataID,itemSellPrice,itemClassID,itemSubClassID,bindType,expacID,itemSetID,isCraftingReagent = GetItemInfo(cursorItemID)

        if checkItemOnGlobalProtectedList(cursorItemID) == true then -- If already on list print item already listed message
            if AVKGlobalSettings.Protect.pialsm == true then
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on your global protect list.")
            end
        else
            if AVKGlobalSettings.Protect.pialsm == true then -- Print item added to list message
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ColourList.textOrange .. " added to your global protect list.")
            end

            tempItemList = {itemID = cursorItemID,itemName = itemName,itemLink = itemLink,itemRarity = itemRarity,itemLevel = itemLevel,itemMinLevel = itemMinLevel,itemType = itemType,itemSubType = itemSubType,itemStackCount = itemStackCount,itemEquipLoc = itemEquipLoc,iconFileDataID = iconFileDataID,itemSellPrice = itemSellPrice,itemClassID = itemClassID,itemSubClassID = itemSubClassID,bindType = bindType,expacID = expacID,itemSetID = itemSetID,isCraftingReagent = isCraftingReagent}

            table.insert(AVKGlobalProtectTable, 1, tempItemList)
            toggleAVKPanels(AardvarkNavigationProtectButton)
        end
    end
    avkUpdateLists()
    ClearCursor()
end

local function addItemToCharacterProtectList()
    local cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= "item" then -- If not item end
        print(ColourList.textBluePrefixSuffix .. " That was not an item.") -- Cannot disable this message, because we have to learn
    else
            local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,iconFileDataID,itemSellPrice,itemClassID,itemSubClassID,bindType,expacID,itemSetID,isCraftingReagent = GetItemInfo(cursorItemID)
        if checkItemOnGlobalProtectedList(cursorItemID) == true then -- If already on list print item already listed message
            if AVKGlobalSettings.Protect.pialsm == true then
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on your global protect list.")
            end
        elseif checkItemOnCharacterProtectedList(cursorItemID) == true then -- If already on list print item already listed message
            if AVKGlobalSettings.Protect.pialsm == true then
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on " .. playerName .. "'s protect list.")
            end
        else
            if AVKGlobalSettings.Protect.pialsm == true then -- Print item added to list message
                print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ColourList.textOrange .. " added to " .. playerName .. "'s protect list.")
            end
            tempItemList = {itemID = cursorItemID,itemName = itemName,itemLink = itemLink,itemRarity = itemRarity,itemLevel = itemLevel,itemMinLevel = itemMinLevel,itemType = itemType,itemSubType = itemSubType,itemStackCount = itemStackCount,itemEquipLoc = itemEquipLoc,iconFileDataID = iconFileDataID,itemSellPrice = itemSellPrice,itemClassID = itemClassID,itemSubClassID = itemSubClassID,bindType = bindType,expacID = expacID,itemSetID = itemSetID,isCraftingReagent = isCraftingReagent}
            table.insert(AVKCharacterProtectTable, 1, tempItemList)
            toggleAVKPanels(AardvarkNavigationProtectButton)
        end
    end
    avkUpdateLists()
    ClearCursor()
end

local function addItemToGlobalList()
    local cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()
    if cursorItemType ~= "item" then -- If not item end
        print(ColourList.textBluePrefixSuffix .. " That was not an item.") -- Cannot disable this message, because we have to learn
    else
        local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,iconFileDataID,itemSellPrice,itemClassID,itemSubClassID,bindType,expacID,itemSetID,isCraftingReagent = GetItemInfo(cursorItemID)

        if itemSellPrice ~= 0 then
            if checkItemOnGlobalSellList(cursorItemID) == true then -- If already on list print item already listed message
                if AVKGlobalSettings.Sell.sialfm == true then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on your global sell list.")
                end
            else -- If not already on list add to list
                if AVKGlobalSettings.Sell.sialsm == true then -- Print item added to list message
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ColourList.textGreen .. " added to your global sell list.")
                end
                tempItemList = {itemID = cursorItemID,itemName = itemName,itemLink = itemLink,itemRarity = itemRarity,itemLevel = itemLevel,itemMinLevel = itemMinLevel,itemType = itemType,itemSubType = itemSubType,itemStackCount = itemStackCount,itemEquipLoc = itemEquipLoc,iconFileDataID = iconFileDataID,itemSellPrice = itemSellPrice,itemClassID = itemClassID,itemSubClassID = itemSubClassID,bindType = bindType,expacID = expacID,itemSetID = itemSetID,isCraftingReagent = isCraftingReagent}
                table.insert(AVKGlobalSellTable, 1, tempItemList)
                toggleAVKPanels(AardvarkNavigationSellButton)
            end
        elseif itemSellPrice == 0 then -- If is item + has no value
            if checkItemOnGlobalDestroyList(cursorItemID) == true then -- If already on list print item already listed message
                if AVKGlobalSettings.Destroy.dialfm == true then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on your global destroy list.")
                end
            else -- If not already on list add to list end
                if AVKGlobalSettings.Destroy.dialsm == true then -- Print item added to list message
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ColourList.textRed .. " added to your global destroy list.")
                end

                tempItemList = {itemID = cursorItemID,itemName = itemName,itemLink = itemLink,itemRarity = itemRarity,itemLevel = itemLevel,itemMinLevel = itemMinLevel,itemType = itemType,itemSubType = itemSubType,itemStackCount = itemStackCount,itemEquipLoc = itemEquipLoc,iconFileDataID = iconFileDataID,itemSellPrice = itemSellPrice,itemClassID = itemClassID,itemSubClassID = itemSubClassID,bindType = bindType,expacID = expacID,itemSetID = itemSetID,isCraftingReagent = isCraftingReagent}

                table.insert(AVKGlobalDestroyTable, 1, tempItemList)
                toggleAVKPanels(AardvarkNavigationDestroyButton)
            end
        end
    end
    avkUpdateLists()
    ClearCursor()
end
local function addItemToCharacterList()
    local cursorItemType, cursorItemID, cursorItemLink = GetCursorInfo()

    if cursorItemType ~= "item" then -- f not item end
        print(ColourList.textBluePrefixSuffix .. " That was not an item.") -- Cannot disable this message, because we have to learn
    else
        local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,iconFileDataID,itemSellPrice,itemClassID,itemSubClassID,bindType,expacID,itemSetID,isCraftingReagent = GetItemInfo(cursorItemID)
        if itemSellPrice ~= 0 then
            if checkItemOnGlobalSellList(cursorItemID) == true then -- If already on list print item already listed message
                if AVKGlobalSettings.Sell.sialfm == true then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on your global sell list.")
                end
            elseif checkItemOnCharacterSellList(cursorItemID) == true then -- If already on list print item already listed message
                if AVKGlobalSettings.Sell.sialfm == true then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on " .. playerName .. "'s sell list.")
                end
            else -- If not already on list add to list
                if AVKGlobalSettings.Sell.sialsm == true then -- Print item added to list message
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ColourList.textGreen .. " added to " .. playerName .. "'s sell list.")
                end

                tempItemList = {itemID = cursorItemID,itemName = itemName,itemLink = itemLink,itemRarity = itemRarity,itemLevel = itemLevel,itemMinLevel = itemMinLevel,itemType = itemType,itemSubType = itemSubType,itemStackCount = itemStackCount,itemEquipLoc = itemEquipLoc,iconFileDataID = iconFileDataID,itemSellPrice = itemSellPrice,itemClassID = itemClassID,itemSubClassID = itemSubClassID,bindType = bindType,expacID = expacID,itemSetID = itemSetID,isCraftingReagent = isCraftingReagent}

                table.insert(AVKCharacterSellTable, 1, tempItemList)
                toggleAVKPanels(AardvarkNavigationSellButton)
            end
        elseif itemSellPrice == 0 then -- If is item + has no value
            if checkItemOnGlobalDestroyList(cursorItemID) == true then -- If already on list print item already listed message
                if AVKGlobalSettings.Destroy.dialfm == true then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on your global destroy list.")
                end
            elseif checkItemOnCharacterDestroyList(cursorItemID) == true then -- If already on list print item already listed message
                if AVKGlobalSettings.Destroy.dialfm == true then
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. " is already on " .. playerName .. "'s destroy list.")
                end
            else -- If not already on list add to list end
                if AVKGlobalSettings.Destroy.dialsm == true then -- Print item added to list message
                    print(ColourList.textBluePrefixSuffix .. cursorItemLink .. ColourList.textRed .. " added to " .. playerName .. "'s destroy list.")
                end

                tempItemList = {itemID = cursorItemID,itemName = itemName,itemLink = itemLink,itemRarity = itemRarity,itemLevel = itemLevel,itemMinLevel = itemMinLevel,itemType = itemType,itemSubType = itemSubType,itemStackCount = itemStackCount,itemEquipLoc = itemEquipLoc,iconFileDataID = iconFileDataID,itemSellPrice = itemSellPrice,itemClassID = itemClassID,itemSubClassID = itemSubClassID,bindType = bindType,expacID = expacID,itemSetID = itemSetID,isCraftingReagent = isCraftingReagent}

                table.insert(AVKCharacterDestroyTable, 1, tempItemList)
                toggleAVKPanels(AardvarkNavigationDestroyButton)
            end
        end
    end
    avkUpdateLists()
    ClearCursor()
end

-- validate vendor
local function checkVendorBlacklist(currentVendor)
    for k, v in pairs(VendorBlacklist) do
        if (v == currentVendor) then
            return true
        end
    end
    return false
end

-- sell function
local function avkSell()
    local vendorGUID, vendorName = UnitGUID("target"), UnitName("target")
    if vendorGUID == nil then -- Catches engineer repair anvils -- debug
        return
    end
    local _, _, _, _, _, npcID, _ = strsplit("-", vendorGUID)
    local vendorID = tonumber(npcID)
    local profitCounter = 0 -- Cash counting variable
    local twelveCounter = 0 -- Twelve item counter
    if checkVendorBlacklist(vendorID) then -- Check if vendor ID is on blacklist
        print(ColourList.textBluePrefixSuffix .. ColourList.textGreen .. vendorName .. " refuses to buy your items.")
    else
        for sellBag = 0, 4 do -- Check each bag
            local sellBagSlot = GetContainerNumSlots(sellBag)
            for sellSlot = 0, sellBagSlot do -- Check each bag slot
                local currentItemID = GetContainerItemID(sellBag, sellSlot)
                if currentItemID then -- If current bag slot has an item then get the item info
                    local _, itemLink, itemQuality, _, _, _, _, _, _, _, itemValue = GetItemInfo(currentItemID)
                    local _, itemCount, _, _, _, _, _, _ = GetContainerItemInfo(sellBag, sellSlot)
                    if
                        (checkItemOnGlobalProtectedList(currentItemID) == true or
                            checkItemOnCharacterProtectedList(currentItemID) == true) and
                            itemValue ~= 0
                     then
                        if AVKGlobalSettings.Sell.sdsm == true and AVKGlobalSettings.Protect.pdpm == true then
                            print(" - Protected: " .. itemLink .. " not sold.")
                        end
                    elseif
                        checkItemOnGlobalSellList(currentItemID) == true or
                            checkItemOnCharacterSellList(currentItemID) == true or
                            (AVKGlobalSettings.Sell.seasg == true and itemQuality == 0)
                     then
                        if twelveCounter ~= 12 then -- Test twelve item count
                            UseContainerItem(sellBag, sellSlot) -- Sell current item -- Comment out to debug
                            if AVKGlobalSettings.Sell.sdsm == true then -- If messages are on
                                print(" - Sold: " .. itemCount .. " " .. itemLink .. " for " .. GetCoinTextureString(itemCount * itemValue))
                            end
                            profitCounter = profitCounter + (itemCount * itemValue) -- Add sale value to profit counter
                            if AVKGlobalSettings.Sell.stil == true then -- If twelve item limit
                                twelveCounter = twelveCounter + 1 -- Increase twelve counter
                            end
                        end
                    end
                end
            end
        end
        if profitCounter ~= 0 then -- If items were sold print out total -- this message cannot be disabled
            print(ColourList.textBluePrefixSuffix .. ColourList.textGreen .. "Total Profit :-|r  " .. GetCoinTextureString(profitCounter))
        elseif AVKGlobalSettings.Sell.sntsm == true then -- If no items sell print out grind message
            print(ColourList.textBluePrefixSuffix .. ColourList.textGreen .. "Nothing to sell. Better grind some more.")
        end
        profitCounter = 0 -- Reset counters
        twelveCounter = 0
    end
    -- Repair print chunk
    if repairMessageType == 1 then
        print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "Repairs paid with guild funds :- |r" .. GetCoinTextureString(repairAmount)) -- Repair message 1
    elseif repairMessageType == 2 then
        print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "Repairs funded by you :- |r" .. GetCoinTextureString(repairAmount)) -- Repair message 2
    elseif repairMessageType == 3 then
        if AVKGlobalSettings.Repair.rcarm == true then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "Guild won't pay and you can't afford it!") -- Repair message 3
        end
    elseif repairMessageType == 4 then
        if AVKGlobalSettings.Repair.rntrm == true then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "Nothing to repair.") -- Repair message 4
        end
    elseif repairMessageType == 5 then
        if AVKGlobalSettings.Repair.rvcrm == true then
            print(ColourList.textBluePrefixSuffix .. ColourList.textPink .. "This vendor cannot repair.") -- Repair message 5
        end
    end
    -- Reset the repair values to 0
    repairAmount = 0
    repairMessageType = 0
end

-- destroy function
local function avkDestroy()
    local destroyedItemCount = 0 -- Destroyed items counting variable
    local destroyedSlotCount = 0
    -- Destroyed slots counting variable
    for destroyBag = 0, 4 do -- Check each bag
        local destroyBagSlot = GetContainerNumSlots(destroyBag)
        for destroySlot = 0, destroyBagSlot do -- Check each bag slot
            local currentItemID = GetContainerItemID(destroyBag, destroySlot)
            if currentItemID then -- If current bag slot has an item then get the item info
                -- 	local itemName,itemLink,itemRarity,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,iconFileDataID,itemSellPrice,itemClassID,itemSubClassID,bindType,expacID,itemSetID,isCraftingReagent=GetItemInfo(v)

                local _, itemLink, _, _, _, _, _, _, _, _, itemValue = GetItemInfo(currentItemID)
                local _, itemCount, _, _, _, _, _, _ = GetContainerItemInfo(destroyBag, destroySlot)
                if
                    (checkItemOnGlobalProtectedList(currentItemID) == true or
                        checkItemOnCharacterProtectedList(currentItemID) == true) and
                        itemValue == 0
                 then
                    if AVKGlobalSettings.Destroy.dddm == true and AVKGlobalSettings.Protect.pdpm == true then -- Print each item destroyed
                        print(" - Protected: " .. itemLink .. " not destroyed.")
                    end
                elseif
                    checkItemOnGlobalDestroyList(currentItemID) == true or
                        checkItemOnCharacterDestroyList(currentItemID) == true
                 then
                    destroyedItemCount = destroyedItemCount + itemCount
                    destroyedSlotCount = destroyedSlotCount + 1
                    -- If item Destroy messages are on print
                    if AVKGlobalSettings.Destroy.dddm == true then -- Print each item destroyed
                        print(" - Destroyed: " .. itemCount .. " " .. itemLink)
                    end
                    PickupContainerItem(destroyBag, destroySlot)
                    DeleteCursorItem() -- Destroy current item --  Comment out to debug
                end
            end
        end
    end
    if destroyedSlotCount ~= 0 then -- If items were destroyed print out total -- If no items destroyed print out bag space message
        print(ColourList.textBluePrefixSuffix .. ColourList.textRed .. "Items destroyed :-|r " .. destroyedItemCount .. ColourList.textRed .. "  ~  Bagslots cleared :-|r " .. destroyedSlotCount)
    elseif AVKGlobalSettings.Destroy.dntdm == true then
        print(ColourList.textBluePrefixSuffix .. ColourList.textRed .. "Nothing destroyed. No bag space saved.")
    end
end

-- repair function
local function avkRepair()
    if CanMerchantRepair() then
        local repairAllCost, _ = GetRepairAllCost()
        if repairAllCost ~= 0 then
            if CanGuildBankRepair() and AVKGlobalSettings.Repair.rgr == true then
                RepairAllItems(1) --  Comment out to debug
                -- Set the repair variables
                repairAmount, repairMessageType = repairAllCost, 1
            elseif GetMoney() >= repairAllCost then
                RepairAllItems() --  Comment out to debug
                repairAmount, repairMessageType = repairAllCost, 2
            elseif GetMoney() < repairAllCost then
                RepairAllItems() --  Comment out to debug
                if AVKGlobalSettings.Repair.rcarm == true then
                    repairAmount, repairMessageType = repairAllCost, 3
                end
            end
        else
            if AVKGlobalSettings.Repair.rntrm == true then
                repairAmount, repairMessageType = repairAllCost, 4
            end
        end
    else
        if AVKGlobalSettings.Repair.rvcrm == true then
            repairAmount, repairMessageType = repairAllCost, 5
        end
    end
end

--[[
-- hook the OpenBackpack function to display the action bar if it is hidden
hooksecurefunc("ToggleBackpack",function()
--        if not AardvarkActionBar:IsVisible() then
--            AardvarkActionBar:Show()
--            print("ToggleBackpack fired")
        end
--    end
)
-- hook the CloseBackpack function to hide the action bar only if always display action bar is checked
hooksecurefunc("CloseBackpack",function()
    --       if AardvarkActionBar:IsVisible() and not AVKGlobalSettings.Aardvark.afabas then
   --         AardvarkActionBar:Hide()
--            print("CloseBackpack fired")
        end
 --   end
)
--]]
-- slash commands
SLASH_AARDVARK1 = "/avk" -- Show frame
function SlashCmdList.AARDVARK(msg, editbox)
    AardvarkMainFrame:Show()
    avkUpdateLists()
end

SLASH_AARDVARKRFP1 = "/avkpos" -- Reset layouts and scales
function SlashCmdList.AARDVARKRFP(msg, editbox)
    AardvarkMainFrame:ClearAllPoints()
    AardvarkMainFrame:SetPoint("LEFT", SizeList.mainFrameSetPoint, 0)
    AVKGlobalSettings.FrameScales.amfs = 1
    AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
    AardvarkMainFrame:Show()
    AardvarkMagicButton:ClearAllPoints()
    AardvarkMagicButton:SetPoint("BOTTOMRIGHT", AardvarkMainFrame, "TOPRIGHT", 0, 20)
    AVKGlobalSettings.FrameScales.ambs = 1
    AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
    AardvarkMagicButton:Show()
    AardvarkActionBar:ClearAllPoints()
    AardvarkActionBar:SetPoint("TOPLEFT", AardvarkMainFrame, "TOPRIGHT", 0, 0)
    AVKGlobalSettings.FrameScales.aabs = 1
    AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    AardvarkActionBar:Show()
    avkUpdateLists()
end

SLASH_AARDVARKD1 = "/avkdestroy" -- Destroy
function SlashCmdList.AARDVARKD(msg, editbox)
    avkDestroy()
end

SLASH_AARDVARKCB1 = "/avkclear" -- Clear all lists
function SlashCmdList.AARDVARKCB(msg, editbox)
    wipe(AVKGlobalSellTable) -- Global Sell
    wipe(AVKGlobalDestroyTable) -- Global Destroy
    wipe(AVKGlobalProtectTable) -- Global Protect
    wipe(AVKCharacterSellTable) -- Character Sell
    wipe(AVKCharacterDestroyTable) -- Character Destroy
    wipe(AVKCharacterProtectTable) -- Character Protect
    avkUpdateLists()
    print(ColourList.textBluePrefix .. "All Lists Cleared")
end

SLASH_AARDVARKSG1 = "/avksg" -- Special add item to global destroy list ignoring value check
function SlashCmdList.AARDVARKSG(msg, editbox)
    local itemID = tonumber(string.match(msg, "item:(%d+):"))
    if checkItemOnGlobalDestroyList(itemID) == true then -- If already on list print item already listed message
        if AVKGlobalSettings.Destroy.dialfm == true then
            print(ColourList.textBluePrefixSuffix .. msg .. " is already on your global destroy list.")
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Destroy.dialsm == true then -- Print item added to list message
            print(ColourList.textBluePrefixSuffix .. msg .. ColourList.textRed .. " added to your global destroy list.")
        end
        table.insert(AVKGlobalDestroyTable, 1, itemID)
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
    avkUpdateLists()
end

SLASH_AARDVARKSC1 = "/avksc" -- Special add item to character destroy list ignoring value check
function SlashCmdList.AARDVARKSC(msg, editbox)
    local itemID = tonumber(string.match(msg, "item:(%d+):"))
    if checkItemOnGlobalDestroyList(itemID) == true then -- If already on list print item already listed message
        if AVKGlobalSettings.Destroy.dialfm == true then
            print(ColourList.textBluePrefixSuffix .. msg .. " is already on your global destroy list.")
        end
    elseif checkItemOnCharacterDestroyList(itemID) == true then
        if AVKGlobalSettings.Destroy.dialfm == true then -- If already on list print item already listed message
            print(ColourList.textBluePrefixSuffix .. msg .. " is already on " .. playerName .. "'s destroy list.")
        end
    else -- If not already on list add to list end
        if AVKGlobalSettings.Destroy.dialsm == true then -- Print item added to list message
            print(ColourList.textBluePrefixSuffix .. msg .. ColourList.textRed .. " added to " .. playerName .. "'s destroy list.")
        end
        table.insert(AVKCharacterDestroyTable, 1, itemID)
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
    avkUpdateLists()
end

-- ===================================================================================================
-- ===========================         AardvarkMainFrame          ===========================
-- ===================================================================================================

local AardvarkMainFrame = CreateFrame("Frame", "AardvarkMainFrame", UIParent, "TooltipBorderedFrameTemplate")
AardvarkMainFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkMainFrame:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkMainFrame:SetSize(SizeList.mainFrameWidth, SizeList.mainFrameHeight)
AardvarkMainFrame:ClearAllPoints()
AardvarkMainFrame:SetPoint("LEFT", SizeList.mainFrameSetPoint, 0)
AardvarkMainFrame:EnableMouse(true)
AardvarkMainFrame:SetMovable(true)
AardvarkMainFrame:RegisterForDrag("RightButton", "LeftButton")
AardvarkMainFrame:SetScript("OnDragStart", AardvarkMainFrame.StartMoving)
AardvarkMainFrame:SetScript("OnDragStop", AardvarkMainFrame.StopMovingOrSizing)
AardvarkMainFrame:SetToplevel(true)
AardvarkMainFrame:SetScript(
    "OnEvent",
    function(self, event, ...) -- Triggers when a registered event fires
        if event == "PLAYER_LOGIN" then
            print(TextList.avkLoad)
            avkInitialise()
            toggleVerticleActionBar()
        elseif event == "MERCHANT_SHOW" then
            if AVKGlobalSettings.Destroy.ded == true and AVKGlobalSettings.Destroy.dead then
                avkDestroy()
            end
            if AVKGlobalSettings.Repair.rer == true then
                avkRepair()
            end
            if AVKGlobalSettings.Sell.ses == true and AVKGlobalSettings.Sell.seas == true then
                avkSell()
            end
            if AVKGlobalSettings.Aardvark.afab == true then
                ActionBarSellButton:Enable()
                AardvarkActionBar:Show()
            else
                AardvarkActionBar:Hide()
            end
        elseif event == "MERCHANT_CLOSED" then
            ActionBarSellButton:Disable()
            if AVKGlobalSettings.Aardvark.afabas == false then
                AardvarkActionBar:Hide()
            end
        elseif event == "GET_ITEM_INFO_RECEIVED" then
            avkUpdateLists()
        end
        AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
        AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
        AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    end
)
AardvarkMainFrame:RegisterEvent("PLAYER_LOGIN") -- Register events to track
AardvarkMainFrame:RegisterEvent("MERCHANT_SHOW")
AardvarkMainFrame:RegisterEvent("MERCHANT_CLOSED")
AardvarkMainFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
AardvarkMainFrame:RegisterEvent("BAG_OPEN")
AardvarkMainFrame:RegisterEvent("BAG_CLOSED")
AardvarkMainFrame:Hide()

local AardvarkMainFrameCloseButton = CreateFrame("Button", "AardvarkMainFrameCloseButton", AardvarkMainFrame)
AardvarkMainFrameCloseButton:SetPoint("TOPRIGHT", SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkMainFrameCloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkMainFrameCloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkMainFrameCloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkMainFrameCloseButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkMainFrameCloseButton)
    end
)

local AardvarkMainFrameBanner = CreateFrame("Frame", "AardvarkOptionsFrameBanner", AardvarkMainFrame)
AardvarkMainFrameBanner:SetSize(590, 90)
AardvarkMainFrameBanner:SetPoint("TOP", 0, -29)
AardvarkMainFrameBanner.Texture = AardvarkMainFrameBanner:CreateTexture(nil, "BACKGROUND")
AardvarkMainFrameBanner.Texture:SetPoint("TOP", 0, 0)
AardvarkMainFrameBanner.Texture:SetTexture(ImageList.avkBanner)

--===================         AardvarkNavigationPanel         ============================
local AardvarkNavigationPanel = CreateFrame("Frame", "AardvarkNavigationPanel", AardvarkMainFrame)
AardvarkNavigationPanel:SetSize(SizeList.mainFrameWidth, SizeList.mainFrameNavigationFrameHeight)
AardvarkNavigationPanel:SetPoint("TOP", 0, -140)

local AardvarkNavigationDestroyButton =
    CreateFrame("Button", "AardvarkNavigationDestroyButton", AardvarkNavigationPanel)
AardvarkNavigationDestroyButton:SetPoint("CENTER", -SizeList.mainFrameNavigationButtonSpace * .5, 0)
AardvarkNavigationDestroyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationDestroyButton:SetNormalTexture(ImageList.destroyButton)
AardvarkNavigationDestroyButton:SetHighlightTexture(ImageList.destroyButtonHover, "BLEND")
AardvarkNavigationDestroyButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationDestroyButton)
    end
)

local AardvarkNavigationSellButton = CreateFrame("Button", "AardvarkNavigationSellButton", AardvarkNavigationPanel)
AardvarkNavigationSellButton:SetPoint(
    "CENTER",
    AardvarkNavigationDestroyButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationSellButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationSellButton:SetNormalTexture(ImageList.sellButton)
AardvarkNavigationSellButton:SetHighlightTexture(ImageList.sellButtonHover, "BLEND")
AardvarkNavigationSellButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationSellButton)
    end
)

local AardvarkNavigationAardvarkButton =
    CreateFrame("Button", "AardvarkNavigationAardvarkButton", AardvarkNavigationPanel)
AardvarkNavigationAardvarkButton:SetPoint(
    "CENTER",
    AardvarkNavigationSellButton,
    -SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationAardvarkButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationAardvarkButton:SetNormalTexture(ImageList.avkButton)
AardvarkNavigationAardvarkButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
AardvarkNavigationAardvarkButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationAardvarkButton)
    end
)

local AardvarkNavigationProtectButton =
    CreateFrame("Button", "AardvarkNavigationProtectButton", AardvarkNavigationPanel)
AardvarkNavigationProtectButton:SetPoint(
    "LEFT",
    AardvarkNavigationDestroyButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationProtectButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationProtectButton:SetNormalTexture(ImageList.protectButton)
AardvarkNavigationProtectButton:SetHighlightTexture(ImageList.protectButtonHover, "BLEND")
AardvarkNavigationProtectButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationProtectButton)
    end
)

local AardvarkNavigationRepairButton = CreateFrame("Button", "AardvarkNavigationRepairButton", AardvarkNavigationPanel)
AardvarkNavigationRepairButton:SetPoint(
    "CENTER",
    AardvarkNavigationProtectButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationRepairButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationRepairButton:SetNormalTexture(ImageList.repairButton)
AardvarkNavigationRepairButton:SetHighlightTexture(ImageList.repairButtonHover, "BLEND")
AardvarkNavigationRepairButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationRepairButton)
    end
)

local AardvarkNavigationSillyButton = CreateFrame("Button", "AardvarkNavigationSillyButton", AardvarkNavigationPanel)
AardvarkNavigationSillyButton:SetPoint(
    "CENTER",
    AardvarkNavigationRepairButton,
    SizeList.mainFrameNavigationButtonSpace,
    0
)
AardvarkNavigationSillyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkNavigationSillyButton:SetNormalTexture(ImageList.avkButton)
AardvarkNavigationSillyButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
AardvarkNavigationSillyButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkNavigationSillyButton)
    end
)

--===================     AardvarkAardvarkPanel     =============================
local AardvarkAardvarkPanel =
    CreateFrame("Frame", "AardvarkAardvarkPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkAardvarkPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkAardvarkPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkAardvarkPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkAardvarkPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkAardvarkPanel:Show()

local CBamfb = CreateFrame("CheckButton", "CBamfb", AardvarkAardvarkPanel, "UICheckButtonTemplate")
CBamfb:ClearAllPoints()
CBamfb:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
CBamfb:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBamfb.text:SetText(ColourList.textBlue .. " Aardvark Button")
CBamfb.text:SetFontObject(FontCheckBoxBig)
CBamfb:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.amfb == true then
            AVKGlobalSettings.Aardvark.amfb = false
            AardvarkMagicButton:Hide()
        else
            AVKGlobalSettings.Aardvark.amfb = true
            AardvarkMagicButton:Show()
        end
    end
)

local CBamfbt = CreateFrame("CheckButton", "CBamfbt", AardvarkAardvarkPanel, "UICheckButtonTemplate")
CBamfbt:ClearAllPoints()
CBamfbt:SetPoint("TOPLEFT", CBamfb, 0, -SizeList.checkboxBigGapY)
CBamfbt:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBamfbt.text:SetText(ColourList.textBlue .. " Aardvark Button Tooltip")
CBamfbt.text:SetFontObject(FontCheckBoxBig)
CBamfbt:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.amfbt == true then
            AVKGlobalSettings.Aardvark.amfbt = false
        else
            AVKGlobalSettings.Aardvark.amfbt = true
        end
    end
)

local CBafab = CreateFrame("CheckButton", "CBafab", AardvarkAardvarkPanel, "UICheckButtonTemplate")
CBafab:ClearAllPoints()
CBafab:SetPoint("TOPLEFT", CBamfbt, 0, -SizeList.checkboxBigGapY)
CBafab:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBafab.text:SetText(ColourList.textBlue .. " Aardvark Action Bar")
CBafab.text:SetFontObject(FontCheckBoxBig)
CBafab:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.afab == true then
            AVKGlobalSettings.Aardvark.afab = false
            CBafabas:Hide()
            CBafabv:Hide()
            AardvarkActionBar:Hide()
        else
            AVKGlobalSettings.Aardvark.afab = true
            if not AardvarkActionBar:IsVisible() then
                CBafabas:Show()
                CBafabv:Show()
                AardvarkActionBar:Show()
            end
        end
    end
)

local CBafabas = CreateFrame("CheckButton", "CBafabas", AardvarkAardvarkPanel, "UICheckButtonTemplate")
CBafabas:ClearAllPoints()
CBafabas:SetPoint("TOPLEFT", CBafab, SizeList.checkBoxChildGapX, -SizeList.checkboxBigGapY)
CBafabas:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBafabas.text:SetText(" Always Show Action Bar")
CBafabas.text:SetFontObject(FontCheckBox)
CBafabas:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.afabas == true then
            AVKGlobalSettings.Aardvark.afabas = false
            toggleFloatingActionBar()
        else
            AVKGlobalSettings.Aardvark.afabas = true
            AardvarkActionBar:Show()
        end
    end
)

local CBafabv = CreateFrame("CheckButton", "CBafabv", AardvarkAardvarkPanel, "UICheckButtonTemplate")
CBafabv:ClearAllPoints()
CBafabv:SetPoint("TOPLEFT", CBafabas, 0, -SizeList.checkboxGapY)
CBafabv:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBafabv.text:SetText(" Verticle Align Action Bar")
CBafabv.text:SetFontObject(FontCheckBox)
CBafabv:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Aardvark.afabv == true then
            AVKGlobalSettings.Aardvark.afabv = false
            toggleVerticleActionBar()
        else
            AVKGlobalSettings.Aardvark.afabv = true
            toggleVerticleActionBar()
        end
    end
)

local AardvarkAardvarkPanelTextBox = CreateFrame("Frame", "AardvarkAardvarkPanelTextBox", AardvarkAardvarkPanel)
AardvarkAardvarkPanelTextBox:SetSize(
    SizeList.mainPanelWidth - SizeList.textBoxWidthShrink,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkAardvarkPanelTextBox:SetPoint("BOTTOMLEFT", SizeList.mainPanelElementGap, SizeList.mainPanelElementGap)
AardvarkAardvarkPanelText = AardvarkAardvarkPanelTextBox:CreateFontString("AardvarkAardvarkPanelText")
AardvarkAardvarkPanelText:SetJustifyH("LEFT")
AardvarkAardvarkPanelText:SetJustifyV("BOTTOM")
AardvarkAardvarkPanelText:SetAllPoints(AardvarkAardvarkPanelTextBox)
AardvarkAardvarkPanelText:SetFontObject(FontContent)
AardvarkAardvarkPanelText:SetText(TextList.avkOptions)

local AardvarkScaleFrameButton =
    CreateFrame("Button", "AardvarkScaleFrameButton", AardvarkAardvarkPanel, "UIMenuButtonStretchTemplate")
AardvarkScaleFrameButton:SetSize(SizeList.scrollFrameWidth * .25, SizeList.clearButtonHight)
AardvarkScaleFrameButton:SetPoint("BOTTOMRIGHT", -10, 10)
AardvarkScaleFrameButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkScaleFrameButton:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkScaleFrameButton:SetNormalFontObject(FontButton)
AardvarkScaleFrameButton:SetHighlightFontObject(FontButton)
AardvarkScaleFrameButton:SetFormattedText("Scale")
AardvarkScaleFrameButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkScaleFrameButton)
    end
)

--===================         AardvarkSideOptionsPanel         ============================
local AardvarkSideOptionsPanel =
    CreateFrame("Frame", "AardvarkSideOptionsPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkSideOptionsPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSideOptionsPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkSideOptionsPanel:SetPoint("TOPLEFT", AardvarkMainFrame, "TOPRIGHT", SizeList.mainFrameMarginGap)
AardvarkSideOptionsPanel:SetSize(SizeList.optionsFrameWidth, SizeList.mainFrameHeight)
AardvarkSideOptionsPanel:SetParent(AardvarkMainFrame)
AardvarkSideOptionsPanel:SetToplevel(true)
AardvarkSideOptionsPanel:Hide()

local AardvarkSideFrameCloseButton = CreateFrame("Button", "AardvarkSideFrameCloseButton", AardvarkSideOptionsPanel)
AardvarkSideFrameCloseButton:SetPoint("TOPRIGHT", SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkSideFrameCloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkSideFrameCloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkSideFrameCloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkSideFrameCloseButton:SetScript(
    "OnClick",
    function(self)
        AardvarkSideOptionsPanel:Hide()
    end
)

--===================         AardvarkSellOptionsPanel         ============================
local AardvarkSellOptionsPanel = CreateFrame("Frame", "AardvarkSellOptionsPanel", AardvarkSideOptionsPanel)
AardvarkSellOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkSellOptionsPanel:SetPoint("TOP", AardvarkSideOptionsPanel, "TOP", SizeList.mainFrameMarginGap)
AardvarkSellOptionsPanel:Hide()

local CBses = CreateFrame("CheckButton", "CBses", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBses:ClearAllPoints()
CBses:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
CBses:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBses.text:SetText(ColourList.textGreen .. " Aardvark Sell")
CBses.text:SetFontObject(FontCheckBoxBig)
CBses:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.ses == true then
            AVKGlobalSettings.Sell.ses = false
            CBseas:Hide()
            CBseasg:Hide()
            CBstil:Hide()
            CBsdsm:Hide()
            CBsntsm:Hide()
            CBsialsm:Hide()
            CBsialfm:Hide()
            CBslit:Hide()
        else
            AVKGlobalSettings.Sell.ses = true
            CBseas:Show()
            CBseasg:Show()
            CBstil:Show()
            CBsdsm:Show()
            CBsntsm:Show()
            CBsialsm:Show()
            CBsialfm:Show()
            CBslit:Show()
        end
    end
)

local CBseas = CreateFrame("CheckButton", "CBseas", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBseas:ClearAllPoints()
CBseas:SetPoint("TOPLEFT", CBses, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
CBseas:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBseas.text:SetText(" Auto Sell")
CBseas.text:SetFontObject(FontCheckBox)
CBseas:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.seas == true then
            AVKGlobalSettings.Sell.seas = false
        else
            AVKGlobalSettings.Sell.seas = true
        end
    end
)

local CBseasg = CreateFrame("CheckButton", "CBseasg", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBseasg:ClearAllPoints()
CBseasg:SetPoint("TOPLEFT", CBseas, 0, -SizeList.checkboxGapY)
CBseasg:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBseasg.text:SetText(" Auto Sell Greys")
CBseasg.text:SetFontObject(FontCheckBox)
CBseasg:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.seasg == true then
            AVKGlobalSettings.Sell.seasg = false
        else
            AVKGlobalSettings.Sell.seasg = true
        end
    end
)

local CBstil = CreateFrame("CheckButton", "CBstil", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBstil:ClearAllPoints()
CBstil:SetPoint("TOPLEFT", CBseasg, 0, -SizeList.checkboxGapY)
CBstil:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBstil.text:SetText(" Sell 12 Items At A Time")
CBstil.text:SetFontObject(FontCheckBox)
CBstil:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.stil == true then
            AVKGlobalSettings.Sell.stil = false
        else
            AVKGlobalSettings.Sell.stil = true
        end
    end
)

local CBsdsm = CreateFrame("CheckButton", "CBsdsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBsdsm:ClearAllPoints()
CBsdsm:SetPoint("TOPLEFT", CBstil, 0, -SizeList.checkboxGapY)
CBsdsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsdsm.text:SetText(" Detailed Sell Messages")
CBsdsm.text:SetFontObject(FontCheckBox)
CBsdsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sdsm == true then
            AVKGlobalSettings.Sell.sdsm = false
        else
            AVKGlobalSettings.Sell.sdsm = true
        end
    end
)

local CBsntsm = CreateFrame("CheckButton", "CBsntsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBsntsm:ClearAllPoints()
CBsntsm:SetPoint("TOPLEFT", CBsdsm, 0, -SizeList.checkboxGapY)
CBsntsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsntsm.text:SetText(" Nothing To Sell Messages")
CBsntsm.text:SetFontObject(FontCheckBox)
CBsntsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sntsm == true then
            AVKGlobalSettings.Sell.sntsm = false
        else
            AVKGlobalSettings.Sell.sntsm = true
        end
    end
)

local CBsialsm = CreateFrame("CheckButton", "CBsialsm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBsialsm:ClearAllPoints()
CBsialsm:SetPoint("TOPLEFT", CBsntsm, 0, -SizeList.checkboxGapY)
CBsialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsialsm.text:SetText(" Item Added Messages")
CBsialsm.text:SetFontObject(FontCheckBox)
CBsialsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sialsm == true then
            AVKGlobalSettings.Sell.sialsm = false
        else
            AVKGlobalSettings.Sell.sialsm = true
        end
    end
)

local CBsialfm = CreateFrame("CheckButton", "CBsialfm", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBsialfm:ClearAllPoints()
CBsialfm:SetPoint("TOPLEFT", CBsialsm, 0, -SizeList.checkboxGapY)
CBsialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBsialfm.text:SetText(" Item Not Added Messages")
CBsialfm.text:SetFontObject(FontCheckBox)
CBsialfm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.sialfm == true then
            AVKGlobalSettings.Sell.sialfm = false
        else
            AVKGlobalSettings.Sell.sialfm = true
        end
    end
)

local CBslit = CreateFrame("CheckButton", "CBslit", AardvarkSellOptionsPanel, "UICheckButtonTemplate")
CBslit:ClearAllPoints()
CBslit:SetPoint("TOPLEFT", CBsialfm, 0, -SizeList.checkboxGapY)
CBslit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBslit.text:SetText(" Show Listed Item Tooltips")
CBslit.text:SetFontObject(FontCheckBox)
CBslit:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Sell.slit == true then
            AVKGlobalSettings.Sell.slit = false
        else
            AVKGlobalSettings.Sell.slit = true
        end
    end
)

local AardvarkSellOptionsPanelTextBox =
    CreateFrame("Frame", "AardvarkSellOptionsPanelTextBox", AardvarkSellOptionsPanel)
AardvarkSellOptionsPanelTextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkSellOptionsPanelTextBox:SetPoint("BOTTOM", AardvarkSideOptionsPanel, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkSellOptionsPanelText = AardvarkSellOptionsPanelTextBox:CreateFontString("AardvarkSellOptionsPanelText")
AardvarkSellOptionsPanelText:SetJustifyH("BOTTOM")
AardvarkSellOptionsPanelText:SetJustifyV("BOTTOM")
AardvarkSellOptionsPanelText:SetAllPoints(AardvarkSellOptionsPanelTextBox)
AardvarkSellOptionsPanelText:SetFontObject(FontContent)
AardvarkSellOptionsPanelText:SetText(TextList.avkSellOptions)

--===================         AardvarkSellPanel         ============================
local AardvarkSellPanel = CreateFrame("Frame", "AardvarkSellPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkSellPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellPanel:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkSellPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkSellPanel:Hide()

local AardvarkSellOptionsButton = CreateFrame("Button", "AardvarkSellOptionsButton", AardvarkSellPanel)
AardvarkSellOptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellOptionsButton:SetPoint(
    "CENTER",
    AardvarkNavigationSillyButton,
    "BOTTOM",
    SizeList.mainFrameNavigationButtonSpace * .5 + SizeList.optionsButtonSize,
    0
)
AardvarkSellOptionsButton:SetNormalTexture(ImageList.sellOptions)
AardvarkSellOptionsButton:SetHighlightTexture(ImageList.sellOptionsHover)
AardvarkSellOptionsButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkSellOptionsButton)
    end
)

local AardvarkSellFiltersButton = CreateFrame("Button", "AardvarkSellFiltersButton", AardvarkSellPanel)
AardvarkSellFiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkSellFiltersButton:SetPoint(
    "CENTER",
    AardvarkNavigationSillyButton,
    "TOP",
    SizeList.mainFrameNavigationButtonSpace * .5 + SizeList.optionsButtonSize,
    0
)
AardvarkSellFiltersButton:SetNormalTexture(ImageList.sellFilters)
AardvarkSellFiltersButton:SetHighlightTexture(ImageList.sellFiltersHover)
AardvarkSellFiltersButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkSellFiltersButton)
    end
)

-- Global Sell
local AardvarkSellGlobalTitle = CreateFrame("Frame", "AardvarkSellGlobalTitle", AardvarkSellPanel)
AardvarkSellGlobalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSellGlobalTitle:SetPoint("TOPLEFT", AardvarkSellPanel, SizeList.scrollTitlePointX, SizeList.scrollTitlePointY)
AardvarkSellGlobalTitleText = AardvarkSellGlobalTitle:CreateFontString("AardvarkSellGlobalTitleText")
AardvarkSellGlobalTitleText:SetPoint("CENTER", 0, 0)
AardvarkSellGlobalTitleText:SetJustifyH("CENTER")
AardvarkSellGlobalTitleText:SetJustifyV("CENTER")
AardvarkSellGlobalTitleText:SetAllPoints(AardvarkSellGlobalTitle)
AardvarkSellGlobalTitleText:SetFontObject(FontTitleScroll)
AardvarkSellGlobalTitleText:SetText("Global Sell List")

local AardvarkSellGlobalScrollParent =
    CreateFrame("Button", "AardvarkSellGlobalScrollParent", AardvarkSellPanel, "TooltipBorderedFrameTemplate")
AardvarkSellGlobalScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellGlobalScrollParent:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellGlobalScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkSellGlobalScrollParent:SetPoint("TOP", AardvarkSellGlobalTitle, "BOTTOM", 0, -8)
AardvarkSellGlobalScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        addItemToGlobalList()
    end
)
AardvarkSellGlobalScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)
local AardvarkSellGlobalScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkSellGlobalScrollFrame",
    AardvarkSellGlobalScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkSellGlobalScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkSellGlobalScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkSellGlobalScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateLists)
    end
)

AardvarkSellGlobalScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkSellGlobalScrollFrame.buttons[i] = CreateFrame("Button", "sglb" .. i, AardvarkSellGlobalScrollParent)
    local button = AardvarkSellGlobalScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = tempGlobalSellTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        addItemToGlobalList()
                    else
                        table.remove(AVKGlobalSellTable, self.index)
                        GameTooltip:Hide()
                        avkUpdateLists()
                    end
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    GameTooltip:Hide()
                    addItemToGlobalList()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkSellGlobalClearListButton =
    CreateFrame("Button", "AardvarkSellGlobalClearListButton", AardvarkSellPanel, "UIMenuButtonStretchTemplate")
AardvarkSellGlobalClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkSellGlobalClearListButton:SetPoint("TOP", AardvarkSellGlobalScrollParent, "BOTTOM", 0, -5)
AardvarkSellGlobalClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellGlobalClearListButton:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellGlobalClearListButton:SetNormalFontObject(FontButton)
AardvarkSellGlobalClearListButton:SetHighlightFontObject(FontButton)
AardvarkSellGlobalClearListButton:SetFormattedText("Clear Global Sell List")
AardvarkSellGlobalClearListButton:RegisterForClicks("RightButtonUp")
AardvarkSellGlobalClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKGlobalSellTable)
        avkUpdateLists()
    end
)

-- Character Sell
local AardvarkSellLocalTitle = CreateFrame("Frame", "AardvarkSellLocalTitle", AardvarkSellPanel)
AardvarkSellLocalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkSellLocalTitle:SetPoint("TOPRIGHT", AardvarkSellPanel, -SizeList.scrollTitlePointX, SizeList.scrollTitlePointY)
AardvarkSellLocalTitleText = AardvarkSellLocalTitle:CreateFontString("AardvarkSellLocalTitleText")
AardvarkSellLocalTitleText:SetPoint("CENTER", 0, 0)
AardvarkSellLocalTitleText:SetJustifyH("CENTER")
AardvarkSellLocalTitleText:SetJustifyV("CENTER")
AardvarkSellLocalTitleText:SetAllPoints(AardvarkSellLocalTitle)
AardvarkSellLocalTitleText:SetFontObject(FontTitleScroll)
AardvarkSellLocalTitleText:SetText(playerName .. "'s\nSell List")

local AardvarkSellCharacterScrollParent =
    CreateFrame("Button", "AardvarkSellCharacterScrollParent", AardvarkSellPanel, "TooltipBorderedFrameTemplate")
AardvarkSellCharacterScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellCharacterScrollParent:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellCharacterScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkSellCharacterScrollParent:SetPoint("TOP", AardvarkSellLocalTitle, "BOTTOM", 0, -8)
AardvarkSellCharacterScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        addItemToCharacterList()
    end
)
AardvarkSellCharacterScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

local AardvarkSellCharacterScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkSellCharacterScrollFrame",
    AardvarkSellCharacterScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkSellCharacterScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkSellCharacterScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkSellCharacterScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateLists)
    end
)

AardvarkSellCharacterScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkSellCharacterScrollFrame.buttons[i] = CreateFrame("Button", "sclb" .. i, AardvarkSellCharacterScrollParent)
    local button = AardvarkSellCharacterScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = tempCharacterSellTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        addItemToCharacterList()
                    else
                        table.remove(AVKCharacterSellTable, self.index)
                        GameTooltip:Hide()
                        avkUpdateLists()
                    end
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    GameTooltip:Hide()
                    addItemToCharacterList()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkSellCharacterClearListButton =
    CreateFrame("Button", "AardvarkSellCharacterClearListButton", AardvarkSellPanel, "UIMenuButtonStretchTemplate")
AardvarkSellCharacterClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkSellCharacterClearListButton:SetPoint("TOP", AardvarkSellCharacterScrollParent, "BOTTOM", 0, -5)
AardvarkSellCharacterClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSellCharacterClearListButton:SetBackdropBorderColor(0, 1, 0, 1)
AardvarkSellCharacterClearListButton:SetNormalFontObject(FontButton)
AardvarkSellCharacterClearListButton:SetHighlightFontObject(FontButton)
AardvarkSellCharacterClearListButton:SetFormattedText("Clear " .. playerName .. "'s Sell List")
AardvarkSellCharacterClearListButton:RegisterForClicks("RightButtonUp")
AardvarkSellCharacterClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKCharacterSellTable)
        avkUpdateLists()
    end
)

--===================         AardvarkDestroyOptionsPanel         ============================
local AardvarkDestroyOptionsPanel = CreateFrame("Frame", "AardvarkDestroyOptionsPanel", AardvarkSideOptionsPanel)
AardvarkDestroyOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkDestroyOptionsPanel:SetPoint("TOP", AardvarkSideOptionsPanel, "TOP", SizeList.mainFrameMarginGap)
AardvarkDestroyOptionsPanel:Hide()

local CBded = CreateFrame("CheckButton", "CBded", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBded:ClearAllPoints()
CBded:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
CBded:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBded.text:SetText(ColourList.textRed .. " Aardvark Destroy")
CBded.text:SetFontObject(FontCheckBoxBig)
CBded:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.ded == true then
            AVKGlobalSettings.Destroy.ded = false
            CBdead:Hide()
            CBdddm:Hide()
            CBdntdm:Hide()
            CBdialsm:Hide()
            CBdialfm:Hide()
            CBdlit:Hide()
        else
            AVKGlobalSettings.Destroy.ded = true
            CBdead:Show()
            CBdddm:Show()
            CBdntdm:Show()
            CBdialsm:Show()
            CBdialfm:Show()
            CBdlit:Show()
        end
    end
)

local CBdead = CreateFrame("CheckButton", "CBdead", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBdead:ClearAllPoints()
CBdead:SetPoint("TOPLEFT", CBded, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
CBdead:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdead.text:SetText(" Auto Destroy")
CBdead.text:SetFontObject(FontCheckBox)
CBdead:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dead == true then
            AVKGlobalSettings.Destroy.dead = false
        else
            AVKGlobalSettings.Destroy.dead = true
        end
    end
)

local CBdddm = CreateFrame("CheckButton", "CBdddm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBdddm:ClearAllPoints()
CBdddm:SetPoint("TOPLEFT", CBdead, 0, -SizeList.checkboxGapY)
CBdddm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdddm.text:SetText(" Detailed Destroy Messages")
CBdddm.text:SetFontObject(FontCheckBox)
CBdddm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dddm == true then
            AVKGlobalSettings.Destroy.dddm = false
        else
            AVKGlobalSettings.Destroy.dddm = true
        end
    end
)

local CBdntdm = CreateFrame("CheckButton", "CBdntdm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBdntdm:ClearAllPoints()
CBdntdm:SetPoint("TOPLEFT", CBdddm, 0, -SizeList.checkboxGapY)
CBdntdm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdntdm.text:SetText(" Nothing To Destroy Messages")
CBdntdm.text:SetFontObject(FontCheckBox)
CBdntdm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dntdm == true then
            AVKGlobalSettings.Destroy.dntdm = false
        else
            AVKGlobalSettings.Destroy.dntdm = true
        end
    end
)

local CBdialsm = CreateFrame("CheckButton", "CBdialsm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBdialsm:ClearAllPoints()
CBdialsm:SetPoint("TOPLEFT", CBdntdm, 0, -SizeList.checkboxGapY)
CBdialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdialsm.text:SetText(" Item Added Messages")
CBdialsm.text:SetFontObject(FontCheckBox)
CBdialsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dialsm == true then
            AVKGlobalSettings.Destroy.dialsm = false
        else
            AVKGlobalSettings.Destroy.dialsm = true
        end
    end
)

local CBdialfm = CreateFrame("CheckButton", "CBdialfm", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBdialfm:ClearAllPoints()
CBdialfm:SetPoint("TOPLEFT", CBdialsm, 0, -SizeList.checkboxGapY)
CBdialfm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdialfm.text:SetText(" Item Not Added Messages")
CBdialfm.text:SetFontObject(FontCheckBox)
CBdialfm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dialfm == true then
            AVKGlobalSettings.Destroy.dialfm = false
        else
            AVKGlobalSettings.Destroy.dialfm = true
        end
    end
)

local CBdlit = CreateFrame("CheckButton", "CBdlit", AardvarkDestroyOptionsPanel, "UICheckButtonTemplate")
CBdlit:ClearAllPoints()
CBdlit:SetPoint("TOPLEFT", CBdialfm, 0, -SizeList.checkboxGapY)
CBdlit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBdlit.text:SetText(" Show Listed Item Tooltips")
CBdlit.text:SetFontObject(FontCheckBox)
CBdlit:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Destroy.dlit == true then
            AVKGlobalSettings.Destroy.dlit = false
        else
            AVKGlobalSettings.Destroy.dlit = true
        end
    end
)

local AardvarkDestroyOptionsPanelTextBox =
    CreateFrame("Frame", "AardvarkDestroyOptionsPanelTextBox", AardvarkDestroyOptionsPanel)
AardvarkDestroyOptionsPanelTextBox:SetSize(
    SizeList.optionsFrameWidth - SizeList.optionsFrameElementGap * 4,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkDestroyOptionsPanelTextBox:SetPoint("BOTTOM", AardvarkSideOptionsPanel, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkDestroyOptionsPanelText = AardvarkDestroyOptionsPanelTextBox:CreateFontString("AardvarkDestroyOptionsPanelText")
AardvarkDestroyOptionsPanelText:SetJustifyH("BOTTOM")
AardvarkDestroyOptionsPanelText:SetJustifyV("BOTTOM")
AardvarkDestroyOptionsPanelText:SetAllPoints(AardvarkDestroyOptionsPanelTextBox)
AardvarkDestroyOptionsPanelText:SetFontObject(FontContent)
AardvarkDestroyOptionsPanelText:SetText(TextList.avkDestroyOptions)

--===================         AardvarkDestroyPanel         ============================
local AardvarkDestroyPanel =
    CreateFrame("Frame", "AardvarkDestroyPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkDestroyPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyPanel:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkDestroyPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkDestroyPanel:Hide()

local AardvarkDestroyOptionsButton = CreateFrame("Button", "AardvarkDestroyOptionsButton", AardvarkDestroyPanel)
AardvarkDestroyOptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyOptionsButton:SetPoint(
    "CENTER",
    AardvarkNavigationSillyButton,
    "BOTTOM",
    SizeList.mainFrameNavigationButtonSpace * .5 + SizeList.optionsButtonSize,
    0
)
AardvarkDestroyOptionsButton:SetNormalTexture(ImageList.destroyOptions)
AardvarkDestroyOptionsButton:SetHighlightTexture(ImageList.destroyOptionsHover)
AardvarkDestroyOptionsButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkDestroyOptionsButton)
    end
)

local AardvarkDestroyFiltersButton = CreateFrame("Button", "AardvarkDestroyFiltersButton", AardvarkDestroyPanel)
AardvarkDestroyFiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkDestroyFiltersButton:SetPoint(
    "CENTER",
    AardvarkNavigationSillyButton,
    "TOP",
    SizeList.mainFrameNavigationButtonSpace * .5 + SizeList.optionsButtonSize,
    0
)
AardvarkDestroyFiltersButton:SetNormalTexture(ImageList.destroyFilters)
AardvarkDestroyFiltersButton:SetHighlightTexture(ImageList.destroyFiltersHover)
AardvarkDestroyFiltersButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkDestroyFiltersButton)
    end
)

-- Global Destroy
local AardvarkDestroyGlobalTitle = CreateFrame("Frame", "AardvarkDestroyGlobalTitle", AardvarkDestroyPanel)
AardvarkDestroyGlobalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkDestroyGlobalTitle:SetPoint(
    "TOPLEFT",
    AardvarkDestroyPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkDestroyGlobalTitleText = AardvarkDestroyGlobalTitle:CreateFontString("AardvarkDestroyGlobalTitleText")
AardvarkDestroyGlobalTitleText:SetPoint("CENTER", 0, 0)
AardvarkDestroyGlobalTitleText:SetJustifyH("CENTER")
AardvarkDestroyGlobalTitleText:SetJustifyV("CENTER")
AardvarkDestroyGlobalTitleText:SetAllPoints(AardvarkDestroyGlobalTitle)
AardvarkDestroyGlobalTitleText:SetFontObject(FontTitleScroll)
AardvarkDestroyGlobalTitleText:SetText("Global Destroy List")

local AardvarkDestroyGlobalScrollParent =
    CreateFrame("Button", "AardvarkDestroyGlobalScrollParent", AardvarkDestroyPanel, "TooltipBorderedFrameTemplate")
AardvarkDestroyGlobalScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyGlobalScrollParent:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyGlobalScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkDestroyGlobalScrollParent:SetPoint("TOP", AardvarkDestroyGlobalTitle, "BOTTOM", 0, -8)
AardvarkDestroyGlobalScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        addItemToGlobalList()
    end
)
AardvarkDestroyGlobalScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)

local AardvarkDestroyGlobalScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkDestroyGlobalScrollFrame",
    AardvarkDestroyGlobalScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkDestroyGlobalScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkDestroyGlobalScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkDestroyGlobalScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateLists)
    end
)

AardvarkDestroyGlobalScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkDestroyGlobalScrollFrame.buttons[i] = CreateFrame("Button", "dglb" .. i, AardvarkDestroyGlobalScrollParent)
    local button = AardvarkDestroyGlobalScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = tempGlobalDestroyTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        addItemToGlobalList()
                    else
                        table.remove(AVKGlobalDestroyTable, self.index)
                        GameTooltip:Hide()
                        avkUpdateLists()
                    end
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    GameTooltip:Hide()
                    addItemToGlobalList()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkDestroyGlobalClearListButton =
    CreateFrame("Button", "AardvarkDestroyGlobalClearListButton", AardvarkDestroyPanel, "UIMenuButtonStretchTemplate")
AardvarkDestroyGlobalClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkDestroyGlobalClearListButton:SetPoint("TOP", AardvarkDestroyGlobalScrollParent, "BOTTOM", 0, -5)
AardvarkDestroyGlobalClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyGlobalClearListButton:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyGlobalClearListButton:SetNormalFontObject(FontButton)
AardvarkDestroyGlobalClearListButton:SetHighlightFontObject(FontButton)
AardvarkDestroyGlobalClearListButton:SetFormattedText("Clear Global Destroy List")
AardvarkDestroyGlobalClearListButton:RegisterForClicks("RightButtonUp")
AardvarkDestroyGlobalClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKGlobalDestroyTable)
        avkUpdateLists()
    end
)

-- Character Destroy
local AardvarkDestroyCharacterTitle = CreateFrame("Frame", "AardvarkDestroyCharacterTitle", AardvarkDestroyPanel)
AardvarkDestroyCharacterTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkDestroyCharacterTitle:SetPoint(
    "TOPRIGHT",
    AardvarkDestroyPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkDestroyCharacterTitleText = AardvarkDestroyCharacterTitle:CreateFontString("AardvarkDestroyCharacterTitleText")
AardvarkDestroyCharacterTitleText:SetPoint("CENTER", 0, 0)
AardvarkDestroyCharacterTitleText:SetJustifyH("CENTER")
AardvarkDestroyCharacterTitleText:SetJustifyV("CENTER")
AardvarkDestroyCharacterTitleText:SetAllPoints(AardvarkDestroyCharacterTitle)
AardvarkDestroyCharacterTitleText:SetFontObject(FontTitleScroll)
AardvarkDestroyCharacterTitleText:SetText(playerName .. "'s\nDestroy List")

local AardvarkDestroyCharacterScrollParent =
    CreateFrame("Button", "AardvarkDestroyCharacterScrollParent", AardvarkDestroyPanel, "TooltipBorderedFrameTemplate")
AardvarkDestroyCharacterScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyCharacterScrollParent:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyCharacterScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkDestroyCharacterScrollParent:SetPoint("TOP", AardvarkDestroyCharacterTitle, "BOTTOM", 0, -8)
AardvarkDestroyCharacterScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        addItemToCharacterList()
    end
)
AardvarkDestroyCharacterScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

local AardvarkDestroyCharacterScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkDestroyCharacterScrollFrame",
    AardvarkDestroyCharacterScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkDestroyCharacterScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkDestroyCharacterScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkDestroyCharacterScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateLists)
    end
)

AardvarkDestroyCharacterScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkDestroyCharacterScrollFrame.buttons[i] = CreateFrame("Button", "dclb" .. i, AardvarkDestroyCharacterScrollParent)
    local button = AardvarkDestroyCharacterScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = tempCharacterDestroyTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        addItemToCharacterList()
                    else
                        table.remove(AVKCharacterDestroyTable, self.index)
                        GameTooltip:Hide()
                        avkUpdateLists()
                    end
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    GameTooltip:Hide()
                    addItemToCharacterList()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkDestroyCharacterClearListButton =
    CreateFrame(
    "Button",
    "AardvarkDestroyCharacterClearListButton",
    AardvarkDestroyPanel,
    "UIMenuButtonStretchTemplate"
)
AardvarkDestroyCharacterClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkDestroyCharacterClearListButton:SetPoint("TOP", AardvarkDestroyCharacterScrollParent, "BOTTOM", 0, -5)
AardvarkDestroyCharacterClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkDestroyCharacterClearListButton:SetBackdropBorderColor(1, 0, 0, 1)
AardvarkDestroyCharacterClearListButton:SetNormalFontObject(FontButton)
AardvarkDestroyCharacterClearListButton:SetHighlightFontObject(FontButton)
AardvarkDestroyCharacterClearListButton:SetFormattedText("Clear " .. playerName .. "'s Destroy List")
AardvarkDestroyCharacterClearListButton:RegisterForClicks("RightButtonUp")
AardvarkDestroyCharacterClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKCharacterDestroyTable)
        avkUpdateLists()
    end
)

--===================         AardvarkProtectOptionsPanel         ============================
local AardvarkProtectOptionsPanel = CreateFrame("Frame", "AardvarkProtectOptionsPanel", AardvarkSideOptionsPanel)
AardvarkProtectOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkProtectOptionsPanel:SetPoint("TOP", AardvarkSideOptionsPanel, "TOP", SizeList.mainFrameMarginGap)
AardvarkProtectOptionsPanel:Hide()

local CBpep = CreateFrame("CheckButton", "CBpep", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
CBpep:ClearAllPoints()
CBpep:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap * 1.5)
CBpep:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpep.text:SetText(ColourList.textOrange .. " Aardvark Protect")
CBpep.text:SetFontObject(FontCheckBoxBig)
CBpep:SetChecked(true)
CBpep:EnableMouse(false)

local CBpialsm = CreateFrame("CheckButton", "CBpialsm", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
CBpialsm:ClearAllPoints()
CBpialsm:SetPoint("TOPLEFT", CBpep, SizeList.checkBoxChildGapX * 1.5, -SizeList.checkboxGapY * 1.2)
CBpialsm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpialsm.text:SetText(" Item Added Messages")
CBpialsm.text:SetFontObject(FontCheckBox)
CBpialsm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pialsm == true then
            AVKGlobalSettings.Protect.pialsm = false
        else
            AVKGlobalSettings.Protect.pialsm = true
        end
    end
)

local CBpdpm = CreateFrame("CheckButton", "CBpdpm", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
CBpdpm:ClearAllPoints()
CBpdpm:SetPoint("TOPLEFT", CBpialsm, 0, -SizeList.checkboxGapY)
CBpdpm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpdpm.text:SetText(" Protected Item Messages")
CBpdpm.text:SetFontObject(FontCheckBox)
CBpdpm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pdpm == true then
            AVKGlobalSettings.Protect.pdpm = false
        else
            AVKGlobalSettings.Protect.pdpm = true
        end
    end
)

local CBpcbp = CreateFrame("CheckButton", "CBpcbp", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
CBpcbp:ClearAllPoints()
CBpcbp:SetPoint("TOPLEFT", CBpdpm, 0, -SizeList.checkboxGapY)
CBpcbp:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBpcbp.text:SetText(" Protect Caged Battle Pets")
CBpcbp.text:SetFontObject(FontCheckBox)
CBpcbp:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.pcbp == true then
            AVKGlobalSettings.Protect.pcbp = false
        else
            AVKGlobalSettings.Protect.pcbp = true
        end
        avkUpdateLists()
    end
)

local CBplit = CreateFrame("CheckButton", "CBplit", AardvarkProtectOptionsPanel, "UICheckButtonTemplate")
CBplit:ClearAllPoints()
CBplit:SetPoint("TOPLEFT", CBpcbp, 0, -SizeList.checkboxGapY)
CBplit:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBplit.text:SetText(" Show Listed Item Tooltips")
CBplit.text:SetFontObject(FontCheckBox)
CBplit:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Protect.plit == true then
            AVKGlobalSettings.Protect.plit = false
        else
            AVKGlobalSettings.Protect.plit = true
        end
    end
)

local AardvarkProtectOptionsPanelTextBox =
    CreateFrame("Frame", "AardvarkProtectOptionsPanelTextBox", AardvarkProtectOptionsPanel)
AardvarkProtectOptionsPanelTextBox:SetSize(
    SizeList.mainFrameWidth / 2,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkProtectOptionsPanelTextBox:SetPoint("BOTTOM", AardvarkSideOptionsPanel, "BOTTOM", 0, SizeList.checkBoxChildGapX)
AardvarkProtectOptionsPanelText = AardvarkProtectOptionsPanelTextBox:CreateFontString("AardvarkProtectOptionsPanelText")
AardvarkProtectOptionsPanelText:SetJustifyH("BOTTOM")
AardvarkProtectOptionsPanelText:SetJustifyV("BOTTOM")
AardvarkProtectOptionsPanelText:SetAllPoints(AardvarkProtectOptionsPanelTextBox)
AardvarkProtectOptionsPanelText:SetFontObject(FontContent)
AardvarkProtectOptionsPanelText:SetText(TextList.avkProtectOptions)

--===================          AardvarkProtectPanel         ============================
local AardvarkProtectPanel =
    CreateFrame("Frame", "AardvarkProtectPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkProtectPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectPanel:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkProtectPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkProtectPanel:Hide()

local AardvarkProtectOptionsButton = CreateFrame("Button", "AardvarkProtectOptionsButton", AardvarkProtectPanel)
AardvarkProtectOptionsButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectOptionsButton:SetPoint(
    "CENTER",
    AardvarkNavigationSillyButton,
    "BOTTOM",
    SizeList.mainFrameNavigationButtonSpace * .5 + SizeList.optionsButtonSize,
    0
)
AardvarkProtectOptionsButton:SetNormalTexture(ImageList.protectOptions)
AardvarkProtectOptionsButton:SetHighlightTexture(ImageList.protectOptionsHover)
AardvarkProtectOptionsButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkProtectOptionsButton)
    end
)

local AardvarkProtectFiltersButton = CreateFrame("Button", "AardvarkProtectFiltersButton", AardvarkProtectPanel)
AardvarkProtectFiltersButton:SetSize(SizeList.optionsButtonSize, SizeList.optionsButtonSize)
AardvarkProtectFiltersButton:SetPoint(
    "CENTER",
    AardvarkNavigationSillyButton,
    "TOP",
    SizeList.mainFrameNavigationButtonSpace * .5 + SizeList.optionsButtonSize,
    0
)
AardvarkProtectFiltersButton:SetNormalTexture(ImageList.protectFilters)
AardvarkProtectFiltersButton:SetHighlightTexture(ImageList.protectFiltersHover)
AardvarkProtectFiltersButton:SetScript(
    "OnClick",
    function()
        toggleAVKPanels(AardvarkProtectFiltersButton)
    end
)

-- Global Protect
local AardvarkProtectGlobalTitle = CreateFrame("Frame", "AardvarkProtectGlobalTitle", AardvarkProtectPanel)
AardvarkProtectGlobalTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkProtectGlobalTitle:SetPoint(
    "TOPLEFT",
    AardvarkProtectPanel,
    SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkProtectPanelTitleText = AardvarkProtectGlobalTitle:CreateFontString("AardvarkProtectPanelTitleText")
AardvarkProtectPanelTitleText:SetPoint("CENTER", 0, 0)
AardvarkProtectPanelTitleText:SetJustifyH("CENTER")
AardvarkProtectPanelTitleText:SetJustifyV("CENTER")
AardvarkProtectPanelTitleText:SetAllPoints(AardvarkProtectGlobalTitle)
AardvarkProtectPanelTitleText:SetFontObject(FontTitleScroll)
AardvarkProtectPanelTitleText:SetText("Global Protect List")

local AardvarkProtectGlobalScrollParent =
    CreateFrame("Button", "AardvarkProtectGlobalScrollParent", AardvarkProtectPanel, "TooltipBorderedFrameTemplate")
AardvarkProtectGlobalScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectGlobalScrollParent:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectGlobalScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkProtectGlobalScrollParent:SetPoint("TOP", AardvarkProtectGlobalTitle, "BOTTOM", 0, -8)
AardvarkProtectGlobalScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        addItemToGlobalProtectList()
    end
)
AardvarkProtectGlobalScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            addItemToGlobalProtectList()
        end
    end
)

local AardvarkProtectGlobalScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkProtectGlobalScrollFrame",
    AardvarkProtectGlobalScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkProtectGlobalScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkProtectGlobalScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkProtectGlobalScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateLists)
    end
)

AardvarkProtectGlobalScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkProtectGlobalScrollFrame.buttons[i] = CreateFrame("Button", "pglb" .. i, AardvarkProtectGlobalScrollParent)
    local button = AardvarkProtectGlobalScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = tempGlobalProtectTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        addItemToGlobalProtectList()
                    else
                        table.remove(AVKGlobalProtectTable, self.index)
                        GameTooltip:Hide()
                        avkUpdateLists()
                    end
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    GameTooltip:Hide()
                    addItemToGlobalProtectList()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkProtectGlobalClearListButton =
    CreateFrame("Button", "AardvarkProtectGlobalClearListButton", AardvarkProtectPanel, "UIMenuButtonStretchTemplate")
AardvarkProtectGlobalClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkProtectGlobalClearListButton:SetPoint("TOP", AardvarkProtectGlobalScrollParent, "BOTTOM", 0, -5)
AardvarkProtectGlobalClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectGlobalClearListButton:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectGlobalClearListButton:SetNormalFontObject(FontButton)
AardvarkProtectGlobalClearListButton:SetHighlightFontObject(FontButton)
AardvarkProtectGlobalClearListButton:SetFormattedText("Clear Global Protect List")
AardvarkProtectGlobalClearListButton:RegisterForClicks("RightButtonUp")
AardvarkProtectGlobalClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKGlobalProtectTable)
        avkUpdateLists()
    end
)

-- Character Protect
local AardvarkProtectCharacterTitle = CreateFrame("Frame", "AardvarkProtectCharacterTitle", AardvarkProtectPanel)
AardvarkProtectCharacterTitle:SetSize(SizeList.scrollFrameWidth, SizeList.scrollTitleHeight)
AardvarkProtectCharacterTitle:SetPoint(
    "TOPRIGHT",
    AardvarkProtectPanel,
    -SizeList.scrollTitlePointX,
    SizeList.scrollTitlePointY
)
AardvarkProtectCharacterTitleText = AardvarkProtectCharacterTitle:CreateFontString("AardvarkProtectCharacterTitleText")
AardvarkProtectCharacterTitleText:SetPoint("CENTER", 0, 0)
AardvarkProtectCharacterTitleText:SetJustifyH("CENTER")
AardvarkProtectCharacterTitleText:SetJustifyV("CENTER")
AardvarkProtectCharacterTitleText:SetAllPoints(AardvarkProtectCharacterTitle)
AardvarkProtectCharacterTitleText:SetFontObject(FontTitleScroll)
AardvarkProtectCharacterTitleText:SetText(playerName .. "'s\nProtect List")

local AardvarkProtectCharacterScrollParent =
    CreateFrame("Button", "AardvarkProtectCharacterScrollParent", AardvarkProtectPanel, "TooltipBorderedFrameTemplate")
AardvarkProtectCharacterScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectCharacterScrollParent:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectCharacterScrollParent:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkProtectCharacterScrollParent:SetPoint("TOP", AardvarkProtectCharacterTitle, "BOTTOM", 0, -8)
AardvarkProtectCharacterScrollParent:SetScript(
    "OnReceiveDrag",
    function()
        addItemToCharacterProtectList()
    end
)
AardvarkProtectCharacterScrollParent:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            addItemToCharacterProtectList()
        end
    end
)

local AardvarkProtectCharacterScrollFrame =
    CreateFrame(
    "ScrollFrame",
    "AardvarkProtectCharacterScrollFrame",
    AardvarkProtectCharacterScrollParent,
    "FauxScrollFrameTemplate"
)
AardvarkProtectCharacterScrollFrame:SetPoint("TOPLEFT", 0, -8)
AardvarkProtectCharacterScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
AardvarkProtectCharacterScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, 16, avkUpdateLists)
    end
)

AardvarkProtectCharacterScrollFrame.buttons = {}
for i = 1, SizeList.scrollButtonNumber do
    AardvarkProtectCharacterScrollFrame.buttons[i] = CreateFrame("Button", "pclb" .. i, AardvarkProtectCharacterScrollParent)
    local button = AardvarkProtectCharacterScrollFrame.buttons[i]
    button:SetSize(SizeList.scrollButtonWidth, SizeList.scrollButtonHeight)
    button:SetNormalFontObject("GameFontHighlightLeft")
    button:SetPoint("TOPLEFT", 8, -(i - 1) * SizeList.scrollButtonHeight - 8)
    button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight2")
    button:SetScript(
        "OnEnter",
        function(self)
            local itemLink = tempCharacterProtectTable[self.index]
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", SizeList.toolTipAnchor, SizeList.toolTipAnchor * .4)
            GameTooltip:SetHyperlink(itemLink)
            if GetCursorInfo() or AVKGlobalSettings.Protect.plit == false then
                GameTooltip:Hide()
            end
            button:SetScript(
                "OnClick",
                function(self)
                    if GetCursorInfo() then
                        addItemToCharacterProtectList()
                    else
                        table.remove(AVKCharacterProtectTable, self.index)
                        GameTooltip:Hide()
                        avkUpdateLists()
                    end
                end
            )
            button:SetScript(
                "OnReceiveDrag",
                function()
                    GameTooltip:Hide()
                    addItemToCharacterProtectList()
                end
            )
        end
    )
    button:SetScript(
        "OnLeave",
        function(self)
            GameTooltip:Hide()
        end
    )
end

local AardvarkProtectCharacterClearListButton =
    CreateFrame(
    "Button",
    "AardvarkProtectCharacterClearListButton",
    AardvarkProtectPanel,
    "UIMenuButtonStretchTemplate"
)
AardvarkProtectCharacterClearListButton:SetSize(SizeList.scrollFrameWidth, SizeList.clearButtonHight)
AardvarkProtectCharacterClearListButton:SetPoint("TOP", AardvarkProtectCharacterScrollParent, "BOTTOM", 0, -5)
AardvarkProtectCharacterClearListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkProtectCharacterClearListButton:SetBackdropBorderColor(1, .5, 0, 1)
AardvarkProtectCharacterClearListButton:SetNormalFontObject(FontButton)
AardvarkProtectCharacterClearListButton:SetHighlightFontObject(FontButton)
AardvarkProtectCharacterClearListButton:SetFormattedText("Clear " .. playerName .. "'s Protect List")
AardvarkProtectCharacterClearListButton:RegisterForClicks("RightButtonUp")
AardvarkProtectCharacterClearListButton:SetScript(
    "OnClick",
    function()
        wipe(AVKCharacterProtectTable)
        avkUpdateLists()
    end
)

--===================          AardvarkRepairPanel         ============================
local AardvarkRepairPanel =
    CreateFrame("Frame", "AardvarkRepairPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkRepairPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkRepairPanel:SetBackdropBorderColor(1, 0, 1, 1)
AardvarkRepairPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkRepairPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkRepairPanel:Hide()

local CBrer = CreateFrame("CheckButton", "CBrer", AardvarkRepairPanel, "UICheckButtonTemplate")
CBrer:ClearAllPoints()
CBrer:SetPoint("TOPLEFT", SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
CBrer:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrer.text:SetText(ColourList.textPink .. " Aardvark Repair")
CBrer.text:SetFontObject(FontCheckBoxBig)
CBrer:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rer == true then
            AVKGlobalSettings.Repair.rer = false
            CBrgr:Hide()
            CBrcarm:Hide()
            CBrntrm:Hide()
            CBrvcrm:Hide()
        else
            AVKGlobalSettings.Repair.rer = true
            CBrgr:Show()
            CBrcarm:Show()
            CBrntrm:Show()
            CBrvcrm:Show()
        end
    end
)

local CBrgr = CreateFrame("CheckButton", "CBrgr", AardvarkRepairPanel, "UICheckButtonTemplate")
CBrgr:ClearAllPoints()
CBrgr:SetPoint("TOPLEFT", CBrer, SizeList.checkBoxChildGapX, -SizeList.checkboxGapY * 1.2)
CBrgr:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrgr.text:SetText(" Guild Repair")
CBrgr.text:SetFontObject(FontCheckBox)
CBrgr:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rgr == true then
            AVKGlobalSettings.Repair.rgr = false
        else
            AVKGlobalSettings.Repair.rgr = true
        end
    end
)

local CBrcarm = CreateFrame("CheckButton", "CBrcarm", AardvarkRepairPanel, "UICheckButtonTemplate")
CBrcarm:ClearAllPoints()
CBrcarm:SetPoint("TOPLEFT", CBrgr, 0, -SizeList.checkboxGapY)
CBrcarm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrcarm.text:SetText(" Cannot Afford Repair Messages")
CBrcarm.text:SetFontObject(FontCheckBox)
CBrcarm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rcarm == true then
            AVKGlobalSettings.Repair.rcarm = false
        else
            AVKGlobalSettings.Repair.rcarm = true
        end
    end
)

local CBrntrm = CreateFrame("CheckButton", "CBrntrm", AardvarkRepairPanel, "UICheckButtonTemplate")
CBrntrm:ClearAllPoints()
CBrntrm:SetPoint("TOPLEFT", CBrcarm, 0, -SizeList.checkboxGapY)
CBrntrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrntrm.text:SetText(" Nothing To Repair Messages")
CBrntrm.text:SetFontObject(FontCheckBox)
CBrntrm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rntrm == true then
            AVKGlobalSettings.Repair.rntrm = false
        else
            AVKGlobalSettings.Repair.rntrm = true
        end
    end
)

local CBrvcrm = CreateFrame("CheckButton", "CBrvcrm", AardvarkRepairPanel, "UICheckButtonTemplate")
CBrvcrm:ClearAllPoints()
CBrvcrm:SetPoint("TOPLEFT", CBrntrm, 0, -SizeList.checkboxGapY)
CBrvcrm:SetSize(SizeList.checkBoxBigSize, SizeList.checkBoxBigSize)
CBrvcrm.text:SetText(" Vendor Cannot Repair Messages")
CBrvcrm.text:SetFontObject(FontCheckBox)
CBrvcrm:SetScript(
    "OnClick",
    function()
        if AVKGlobalSettings.Repair.rvcrm == true then
            AVKGlobalSettings.Repair.rvcrm = false
        else
            AVKGlobalSettings.Repair.rvcrm = true
        end
    end
)

local AardvarkRepairPanelTextBox = CreateFrame("Frame", "AardvarkRepairPanelTextBox", AardvarkRepairPanel)
AardvarkRepairPanelTextBox:SetSize(
    SizeList.scrollFrameWidth - SizeList.textBoxWidthShrink,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkRepairPanelTextBox:SetPoint("TOPRIGHT", -SizeList.mainPanelElementGap, -SizeList.mainPanelElementGap)
AardvarkRepairPanelText = AardvarkRepairPanelTextBox:CreateFontString("AardvarkRepairPanelText")
AardvarkRepairPanelText:SetJustifyH("CENTER")
AardvarkRepairPanelText:SetJustifyV("TOP")
AardvarkRepairPanelText:SetAllPoints(AardvarkRepairPanelTextBox)
AardvarkRepairPanelText:SetFontObject(FontContent)
AardvarkRepairPanelText:SetText(TextList.avkRepairOptions)

--===================         AardvarkSillyPanel         ============================
local AardvarkSillyPanel = CreateFrame("Frame", "AardvarkSillyPanel", AardvarkMainFrame, "TooltipBorderedFrameTemplate")
AardvarkSillyPanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkSillyPanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkSillyPanel:SetSize(SizeList.mainPanelWidth, SizeList.mainPanelHeight)
AardvarkSillyPanel:SetPoint("BOTTOM", 0, SizeList.mainFrameMarginGap)
AardvarkSillyPanel:Hide()

local AardvarkSillyPanelTextBox = CreateFrame("Frame", "AardvarkSillyPanelTextBox", AardvarkSillyPanel)
AardvarkSillyPanelTextBox:SetSize(
    SizeList.mainPanelWidth - SizeList.mainPanelElementGap,
    SizeList.mainPanelHeight - SizeList.mainPanelElementGap
)
AardvarkSillyPanelTextBox:SetPoint("TOP", AardvarkSillyPanel, 0, -11)
AardvarkSillyText = AardvarkSillyPanelTextBox:CreateFontString("AardvarkSillyText")
AardvarkSillyText:SetAllPoints(AardvarkSillyPanelTextBox)
AardvarkSillyText:SetFontObject(FontContent)
AardvarkSillyText:SetText(TextList.avkAboutAardvark)

--===================         AardvarkScalePanel         ============================
local AardvarkScalePanel = CreateFrame("Frame", "AardvarkScalePanel", UIParent, "TooltipBorderedFrameTemplate")
AardvarkScalePanel:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = SizeList.backdropEdgeSize
    }
)
AardvarkScalePanel:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkScalePanel:ClearAllPoints()
AardvarkScalePanel:SetPoint("BOTTOMRIGHT", AardvarkMainFrame, "BOTTOMLEFT", SizeList.mainFrameSetPoint, 0)
AardvarkScalePanel:SetSize(SizeList.scrollFrameWidth, SizeList.scrollFrameHeight)
AardvarkScalePanel:SetParent(AardvarkMainFrame)
AardvarkScalePanel:SetClampedToScreen(true)
AardvarkScalePanel:EnableMouse(true)
AardvarkScalePanel:SetMovable(true)
AardvarkScalePanel:RegisterForDrag("RightButton", "LeftButton")
AardvarkScalePanel:SetScript("OnDragStart", AardvarkScalePanel.StartMoving)
AardvarkScalePanel:SetScript("OnDragStop", AardvarkScalePanel.StopMovingOrSizing)
AardvarkScalePanel:SetToplevel(true)
AardvarkScalePanel:Hide()

local AardvarkScaleFrameCloseButton = CreateFrame("Button", "AardvarkScaleFrameCloseButton", AardvarkScalePanel)
AardvarkScaleFrameCloseButton:SetPoint("TOPRIGHT", SizeList.closeButtonGap, SizeList.closeButtonGap)
AardvarkScaleFrameCloseButton:SetSize(SizeList.closeButtonSize, SizeList.closeButtonSize)
AardvarkScaleFrameCloseButton:SetNormalTexture(ImageList.avkCloseButton)
AardvarkScaleFrameCloseButton:SetHighlightTexture(ImageList.avkCloseButtonHover)
AardvarkScaleFrameCloseButton:SetScript(
    "OnClick",
    function(self)
        AardvarkScalePanel:Hide()
    end
)

local AardvarkMagicButtonScaler =
    CreateFrame("Slider", "AardvarkMagicButtonScaler", AardvarkScalePanel, "OptionsSliderTemplate")
AardvarkMagicButtonScaler:SetPoint("CENTER", 0, 0)
AardvarkMagicButtonScaler:SetScale(SizeList.scaleSliderScale)
AardvarkMagicButtonScaler.textLow = _G["AardvarkMagicButtonScaler" .. "Low"]
AardvarkMagicButtonScaler.textHigh = _G["AardvarkMagicButtonScaler" .. "High"]
AardvarkMagicButtonScaler.text = _G["AardvarkMagicButtonScaler" .. "Text"]
AardvarkMagicButtonScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkMagicButtonScaler.minValue, AardvarkMagicButtonScaler.maxValue = AardvarkMagicButtonScaler:GetMinMaxValues()
AardvarkMagicButtonScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ("%"))
AardvarkMagicButtonScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ("%"))
AardvarkMagicButtonScalerText:SetFontObject(FontButton)
AardvarkMagicButtonScalerText:SetText(ColourList.textBlue .. "Aardvark Button")
AardvarkMagicButtonScaler:SetValue(.5)
AardvarkMagicButtonScaler:SetValueStep(1)
AardvarkMagicButtonScaler:SetScript(
    "OnValueChanged",
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.ambs = tonumber(event)
        AardvarkMagicButton:SetScale(AVKGlobalSettings.FrameScales.ambs)
    end
)

local AardvarkMainFrameScaler =
    CreateFrame("Slider", "AardvarkMainFrameScaler", AardvarkScalePanel, "OptionsSliderTemplate")
AardvarkMainFrameScaler:SetPoint("CENTER", AardvarkMagicButtonScaler, 0, SizeList.scaleButtonGap)
AardvarkMainFrameScaler:SetScale(SizeList.scaleSliderScale)
AardvarkMainFrameScaler.textLow = _G["AardvarkMainFrameScaler" .. "Low"]
AardvarkMainFrameScaler.textHigh = _G["AardvarkMainFrameScaler" .. "High"]
AardvarkMainFrameScaler.text = _G["AardvarkMainFrameScaler" .. "Text"]
AardvarkMainFrameScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkMainFrameScaler.minValue, AardvarkMainFrameScaler.maxValue = AardvarkMainFrameScaler:GetMinMaxValues()
AardvarkMainFrameScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ("%"))
AardvarkMainFrameScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ("%"))
AardvarkMainFrameScalerText:SetFontObject(FontButton)
AardvarkMainFrameScalerText:SetText(ColourList.textBlue .. "Aardvark Frame")
AardvarkMainFrameScaler:SetValue(.5)
AardvarkMainFrameScaler:SetValueStep(1)
AardvarkMainFrameScaler:SetScript(
    "OnValueChanged",
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.amfs = tonumber(event)
        AardvarkMainFrame:SetScale(AVKGlobalSettings.FrameScales.amfs)
    end
)

local AardvarkActionBarScaler =
    CreateFrame("Slider", "AardvarkActionBarScaler", AardvarkScalePanel, "OptionsSliderTemplate")
AardvarkActionBarScaler:SetPoint("CENTER", AardvarkMagicButtonScaler, 0, -SizeList.scaleButtonGap)
AardvarkActionBarScaler:SetScale(SizeList.scaleSliderScale)
AardvarkActionBarScaler.textLow = _G["AardvarkActionBarScaler" .. "Low"]
AardvarkActionBarScaler.textHigh = _G["AardvarkActionBarScaler" .. "High"]
AardvarkActionBarScaler.text = _G["AardvarkActionBarScaler" .. "Text"]
AardvarkActionBarScaler:SetMinMaxValues(SizeList.scaleSliderMin, SizeList.scaleSliderMax)
AardvarkActionBarScaler.minValue, AardvarkActionBarScaler.maxValue = AardvarkActionBarScaler:GetMinMaxValues()
AardvarkActionBarScaler.textLow:SetText((SizeList.scaleSliderMin * 100) .. ("%"))
AardvarkActionBarScaler.textHigh:SetText((SizeList.scaleSliderMax * 100) .. ("%"))
AardvarkActionBarScalerText:SetFontObject(FontButton)
AardvarkActionBarScalerText:SetText(ColourList.textBlue .. "Aardvark Action Bar")
AardvarkActionBarScaler:SetValue(1)
AardvarkActionBarScaler:SetValueStep(1)
AardvarkActionBarScaler:SetScript(
    "OnValueChanged",
    function(self, event, arg1)
        AVKGlobalSettings.FrameScales.aabs = tonumber(event)
        AardvarkActionBar:SetScale(AVKGlobalSettings.FrameScales.aabs)
    end
)

-- ===================================================================================================
-- ===========================         AardvarkMagicButton          ===========================
-- ===================================================================================================

AardvarkMagicButton = CreateFrame("Button", "AardvarkMagicButton", UIParent)
AardvarkMagicButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
AardvarkMagicButton:ClearAllPoints()
AardvarkMagicButton:SetPoint("BOTTOMRIGHT", AardvarkMainFrame, "TOPRIGHT", 0, 20)
AardvarkMagicButton:SetNormalTexture(ImageList.avkButton)
AardvarkMagicButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
AardvarkMagicButton:SetMovable(true)
AardvarkMagicButton:SetClampedToScreen(true)
AardvarkMagicButton:RegisterForDrag("MiddleButton")
AardvarkMagicButton:SetScript("OnDragStart", AardvarkMagicButton.StartMoving)
AardvarkMagicButton:SetScript("OnDragStop", AardvarkMagicButton.StopMovingOrSizing)
AardvarkMagicButton:SetToplevel(true)
AardvarkMagicButton:SetScript(
    "OnEnter",
    function(self)
        GameTooltip:SetOwner(self, "ANCHOR_TOP", 5, 5)
        GameTooltip:AddDoubleLine(addonName, versionNumber, 0, 1, 1, 0, 1, 1)
        GameTooltip:AddLine(TextList.avkMagicButton)
        if AVKGlobalSettings.Aardvark.amfbt == true then
            GameTooltip:Show()
        else
            GameTooltip:Hide()
        end
        AardvarkMagicButton:SetScript(
            "OnReceiveDrag",
            function()
                if GetCursorInfo() then
                    if IsAltKeyDown() then
                        addItemToGlobalList()
                    else
                        addItemToCharacterList()
                    end
                end
            end
        )
        AardvarkMagicButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
        AardvarkMagicButton:SetScript(
            "OnClick",
            function(self, button)
                if button == "RightButton" then
                    avkDestroy()
                elseif button == "LeftButton" then
                    if GetCursorInfo() then
                        if IsControlKeyDown() then
                            addItemToGlobalProtectList()
                        elseif IsAltKeyDown() then
                            addItemToGlobalList()
                        else
                            addItemToCharacterList()
                        end
                    else
                        if AardvarkMainFrame:IsVisible() then
                            avkUpdateLists()
                            AardvarkMainFrame:Hide()
                        else
                            AardvarkMainFrame:Show()
                        end
                    end
                end
            end
        )
    end
)
AardvarkMagicButton:SetScript(
    "OnLeave",
    function(self)
        GameTooltip:Hide()
        GameTooltip:SetScale(1)
    end
)

-- ===================================================================================================
-- ===========================         AardvarkActionBar          ===========================
-- ===================================================================================================

AardvarkActionBar = CreateFrame("Frame", "AardvarkActionBar", UIParent)
AardvarkActionBar:SetBackdropBorderColor(0, 1, 1, 1)
AardvarkActionBar:SetMovable(true)
AardvarkActionBar:SetClampedToScreen(true)
AardvarkActionBar:SetToplevel(true)
AardvarkActionBar:Hide()

ActionBarAardvarkButton = CreateFrame("Button", "ActionBarAardvarkButton", AardvarkActionBar)
ActionBarAardvarkButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarAardvarkButton:SetNormalTexture(ImageList.avkButton)
ActionBarAardvarkButton:SetHighlightTexture(ImageList.avkButtonHover, "BLEND")
ActionBarAardvarkButton:EnableMouse(true)
ActionBarAardvarkButton:SetMovable(true)
ActionBarAardvarkButton:SetClampedToScreen(true)
ActionBarAardvarkButton:RegisterForDrag("MiddleButton")
ActionBarAardvarkButton:SetScript(
    "OnDragStart",
    function()
        ActionBarAardvarkButton:GetParent():StartMoving()
    end
)
ActionBarAardvarkButton:SetScript(
    "OnDragStop",
    function()
        ActionBarAardvarkButton:GetParent():StopMovingOrSizing()
    end
)
ActionBarAardvarkButton:SetScript(
    "OnClick",
    function()
        if AardvarkMainFrame:IsVisible() then
            avkUpdateLists()
            AardvarkMainFrame:Hide()
        else
            AardvarkMainFrame:Show()
        end
    end
)

ActionBarDestroyButton = CreateFrame("Button", "ActionBarDestroyButton", AardvarkActionBar)
ActionBarDestroyButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarDestroyButton:SetNormalTexture(ImageList.destroyButton)
ActionBarDestroyButton:SetHighlightTexture(ImageList.destroyButtonHover, "BLEND")
ActionBarDestroyButton:RegisterForClicks("RightButtonUp")
ActionBarDestroyButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            avkDestroy()
        end
    end
)

ActionBarSellButton = CreateFrame("Button", "ActionBarSellButton", AardvarkActionBar)
ActionBarSellButton:SetSize(SizeList.mainFrameNavigationButtonSize, SizeList.mainFrameNavigationButtonSize)
ActionBarSellButton:SetNormalTexture(ImageList.sellButton)
ActionBarSellButton:SetHighlightTexture(ImageList.sellButtonHover, "BLEND")
ActionBarSellButton:SetDisabledTexture(ImageList.sellOutOfRange)
ActionBarSellButton:Disable()
ActionBarSellButton:SetScript(
    "OnClick",
    function(self, button)
        avkSell()
    end
)

ActionBarProtectGlobalButton = CreateFrame("Button", "ActionBarProtectGlobalButton", AardvarkActionBar)
ActionBarProtectGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarProtectGlobalButton:SetNormalTexture(ImageList.protectGlobal)
ActionBarProtectGlobalButton:SetHighlightTexture(ImageList.protectGlobalHover, "BLEND")
ActionBarProtectGlobalButton:SetScript("OnReceiveDrag", addItemToGlobalProtectList)
ActionBarProtectGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            addItemToGlobalProtectList()
        end
    end
)

ActionBarProtectCharacterButton = CreateFrame("Button", "ActionBarProtectCharacterButton", AardvarkActionBar)
ActionBarProtectCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarProtectCharacterButton:SetNormalTexture(ImageList.protectCharacter)
ActionBarProtectCharacterButton:SetHighlightTexture(ImageList.protectCharacterHover, "BLEND")
ActionBarProtectCharacterButton:SetScript("OnReceiveDrag", addItemToCharacterProtectList)
ActionBarProtectCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            addItemToCharacterProtectList()
        end
    end
)

ActionBarDestroyGlobalButton = CreateFrame("Button", "ActionBarDestroyGlobalButton", AardvarkActionBar)
ActionBarDestroyGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarDestroyGlobalButton:SetNormalTexture(ImageList.destroyGlobal)
ActionBarDestroyGlobalButton:SetHighlightTexture(ImageList.destroyGlobalHover, "BLEND")
ActionBarDestroyGlobalButton:SetScript("OnReceiveDrag", addItemToGlobalList)
ActionBarDestroyGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)

ActionBarDestroyCharacterButton = CreateFrame("Button", "ActionBarDestroyCharacterButton", AardvarkActionBar)
ActionBarDestroyCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarDestroyCharacterButton:SetNormalTexture(ImageList.destroyCharacter)
ActionBarDestroyCharacterButton:SetHighlightTexture(ImageList.destroyCharacterHover, "BLEND")
ActionBarDestroyCharacterButton:SetScript("OnReceiveDrag", addItemToCharacterList)
ActionBarDestroyCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

ActionBarSellGlobalButton = CreateFrame("Button", "ActionBarSellGlobalButton", AardvarkActionBar)
ActionBarSellGlobalButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarSellGlobalButton:SetNormalTexture(ImageList.sellGlobal)
ActionBarSellGlobalButton:SetHighlightTexture(ImageList.sellGlobalHover, "BLEND")
ActionBarSellGlobalButton:SetScript("OnReceiveDrag", addItemToGlobalList)
ActionBarSellGlobalButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            addItemToGlobalList()
        end
    end
)

ActionBarSellCharacterButton = CreateFrame("Button", "ActionBarSellCharacterButton", AardvarkActionBar)
ActionBarSellCharacterButton:SetSize(SizeList.actionBarSmallButton, SizeList.actionBarSmallButton)
ActionBarSellCharacterButton:SetNormalTexture(ImageList.sellCharacter)
ActionBarSellCharacterButton:SetHighlightTexture(ImageList.sellCharacterHover, "BLEND")
ActionBarSellCharacterButton:SetScript("OnReceiveDrag", addItemToCharacterList)
ActionBarSellCharacterButton:SetScript(
    "OnClick",
    function(self, button)
        if GetCursorInfo() then
            addItemToCharacterList()
        end
    end
)

--===================         AardvarkFilterOptionsPanel         ============================
local AardvarkFilterOptionsPanel = CreateFrame("Frame", "AardvarkFilterOptionsPanel", AardvarkSideOptionsPanel)
AardvarkFilterOptionsPanel:SetSize(
    SizeList.mainFrameWidth / 2 + SizeList.mainFrameMarginGap * 2,
    SizeList.mainFrameHeight
)
AardvarkFilterOptionsPanel:SetPoint("TOP", AardvarkSideOptionsPanel, "TOP", SizeList.mainFrameMarginGap)
AardvarkFilterOptionsPanel:Hide()

local CB_rarity_poor = CreateFrame("CheckButton", "CB_rarity_poor", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_poor:ClearAllPoints()
CB_rarity_poor:SetPoint("TOPLEFT", AardvarkFilterOptionsPanel, 14, -SizeList.checkboxGapY)
CB_rarity_poor:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_poor.text:SetText(ColourList.rarityPoor .. "  Poor")
CB_rarity_poor.text:SetFontObject(FontCheckBox)
CB_rarity_poor:SetChecked(true)
CB_rarity_poor:SetScript(
    "OnClick",
    function()
        if FilterList.rarityPoor == true then
            FilterList.rarityPoor = false
        else
            FilterList.rarityPoor = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_common =
    CreateFrame("CheckButton", "CB_rarity_common", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_common:ClearAllPoints()
CB_rarity_common:SetPoint("BOTTOM", CB_rarity_poor, 0, -SizeList.checkboxGapY)
CB_rarity_common:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_common.text:SetText(ColourList.rarityCommon .. "  Common")
CB_rarity_common.text:SetFontObject(FontCheckBox)
CB_rarity_common:SetChecked(true)
CB_rarity_common:SetScript(
    "OnClick",
    function()
        if FilterList.rarityCommon == true then
            FilterList.rarityCommon = false
        else
            FilterList.rarityCommon = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_uncommon =
    CreateFrame("CheckButton", "CB_rarity_uncommon", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_uncommon:ClearAllPoints()
CB_rarity_uncommon:SetPoint("BOTTOM", CB_rarity_common, 0, -SizeList.checkboxGapY)
CB_rarity_uncommon:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_uncommon.text:SetText(ColourList.rarityUncommon .. "  Uncommon")
CB_rarity_uncommon.text:SetFontObject(FontCheckBox)
CB_rarity_uncommon:SetChecked(true)
CB_rarity_uncommon:SetScript(
    "OnClick",
    function()
        if FilterList.rarityUncommon == true then
            FilterList.rarityUncommon = false
        else
            FilterList.rarityUncommon = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_rare = CreateFrame("CheckButton", "CB_rarity_rare", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_rare:ClearAllPoints()
CB_rarity_rare:SetPoint("BOTTOM", CB_rarity_uncommon, 0, -SizeList.checkboxGapY)
CB_rarity_rare:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_rare.text:SetText(ColourList.rarityRare .. "  Rare")
CB_rarity_rare.text:SetFontObject(FontCheckBox)
CB_rarity_rare:SetChecked(true)
CB_rarity_rare:SetScript(
    "OnClick",
    function()
        if FilterList.rarityRare == true then
            FilterList.rarityRare = false
        else
            FilterList.rarityRare = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_epic = CreateFrame("CheckButton", "CB_rarity_epic", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_epic:ClearAllPoints()
CB_rarity_epic:SetPoint("RIGHT", CB_rarity_poor, SizeList.checkboxGapY * 5.5, 0)
CB_rarity_epic:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_epic.text:SetText(ColourList.rarityEpic .. "  Epic")
CB_rarity_epic.text:SetFontObject(FontCheckBox)
CB_rarity_epic:SetChecked(true)
CB_rarity_epic:SetScript(
    "OnClick",
    function()
        if FilterList.rarityEpic == true then
            FilterList.rarityEpic = false
        else
            FilterList.rarityEpic = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_legendary =
    CreateFrame("CheckButton", "CB_rarity_legendary", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_legendary:ClearAllPoints()
CB_rarity_legendary:SetPoint("BOTTOM", CB_rarity_epic, 0, -SizeList.checkboxGapY)
CB_rarity_legendary:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_legendary.text:SetText(ColourList.rarityLegendary .. "  Legendary")
CB_rarity_legendary.text:SetFontObject(FontCheckBox)
CB_rarity_legendary:SetChecked(true)
CB_rarity_legendary:SetScript(
    "OnClick",
    function()
        if FilterList.rarityLegendary == true then
            FilterList.rarityLegendary = false
        else
            FilterList.rarityLegendary = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_artifact =
    CreateFrame("CheckButton", "CB_rarity_artifact", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_artifact:ClearAllPoints()
CB_rarity_artifact:SetPoint("BOTTOM", CB_rarity_legendary, 0, -SizeList.checkboxGapY)
CB_rarity_artifact:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_artifact.text:SetText(ColourList.rarityArtifact .. "  Artifact")
CB_rarity_artifact.text:SetFontObject(FontCheckBox)
CB_rarity_artifact:SetChecked(true)
CB_rarity_artifact:SetScript(
    "OnClick",
    function()
        if FilterList.rarityArtifact == true then
            FilterList.rarityArtifact = false
        else
            FilterList.rarityArtifact = true
        end
        avkUpdateLists()
    end
)

local CB_rarity_heirloom =
    CreateFrame("CheckButton", "CB_rarity_heirloom", AardvarkFilterOptionsPanel, "UICheckButtonTemplate")
CB_rarity_heirloom:ClearAllPoints()
CB_rarity_heirloom:SetPoint("BOTTOM", CB_rarity_artifact, 0, -SizeList.checkboxGapY)
CB_rarity_heirloom:SetSize(SizeList.checkBoxSize, SizeList.checkBoxSize)
CB_rarity_heirloom.text:SetText(ColourList.rarityHeirloom .. "  Heirloom")
CB_rarity_heirloom.text:SetFontObject(FontCheckBox)
CB_rarity_heirloom:SetChecked(true)
CB_rarity_heirloom:SetScript(
    "OnClick",
    function()
        if FilterList.rarityHeirloom == true then
            FilterList.rarityHeirloom = false
        else
            FilterList.rarityHeirloom = true
        end
        avkUpdateLists()
    end
)
